import { CreateStoreMetadataParams as $64$luvio_engine_CreateStoreMetadataParams } from '@luvio/engine';
export type PaginationMetadata = Record<string, number | undefined>;
export type NullableToken = string | null;
export type TokenMissing = undefined;
interface PageInfo {
    startCursor: string | null;
    endCursor: string | null;
    hasNextPage: boolean;
    hasPreviousPage: boolean;
    __typename: string;
}
export declare const PAGINATION_VERSION = "0.111.0";
export declare const paginationStoreMetadata: $64$luvio_engine_CreateStoreMetadataParams;
export interface PaginationParams {
    token: string | undefined;
    pageSize: number;
}
export interface PageMetadata {
    startOffset?: number;
    endOffset?: number;
    metadataProperties: Record<string, unknown>;
}
interface GraphQLEdge {
    cursor: string;
}
export declare function createPaginationMetadata(startOffset: number, edges: GraphQLEdge[]): PaginationMetadata;
export declare function createPageInfo(edges: any[] | undefined, startOffset?: number, endOffset?: number, maxOffset?: number, metadata?: PaginationMetadata): PageInfo | undefined;
export declare function findMaxOffset(metadata: PaginationMetadata | undefined): number;
export declare function getPageTokenAndOffset(paginationMetadata: PaginationMetadata, token: string | undefined): [string, number] | undefined;
export declare function hasGraphQLPaginationFields(data: any): boolean;
export declare function mergeMetadata(existingMetadata: PaginationMetadata | undefined, incomingMetadata: PaginationMetadata): PaginationMetadata;
export declare function getNextPageToken(paginationMetadata: PaginationMetadata, pageEndOffset: number): NullableToken | TokenMissing;
export declare function offsetFromToken(paginationMetadata: PaginationMetadata, token: string | undefined): number;
export declare function pageEndOffset(paginationMetadata: PaginationMetadata, startOffset: number, pageSize: number): number;
export declare function getPreviousPageToken(paginationMetadata: PaginationMetadata, startOffset: number, pageSize: number): NullableToken | TokenMissing;
export declare function tokenFromOffset(paginationMetadata: PaginationMetadata, offset: number): string | TokenMissing;
export declare function tokenForAtMost(paginationMetadata: PaginationMetadata, maxOffset: number): [string | undefined, number];
export declare function trimEdges(edges: any[] | undefined, startOffset: number, endOffset: number): any[] | undefined;
export declare function optimizePagination(metadata: PaginationMetadata, firstArgName: string, afterArgName: string, variables: any): void;
export declare function revertPaginationOptimization(variables: any): void;
export {};
