import { Luvio as $64$luvio_engine_Luvio, Fragment as $64$luvio_engine_Fragment, FetchResponse as $64$luvio_engine_FetchResponse, FulfilledSnapshot as $64$luvio_engine_FulfilledSnapshot, StaleSnapshot as $64$luvio_engine_StaleSnapshot, PendingSnapshot as $64$luvio_engine_PendingSnapshot, ResourceRequest as $64$luvio_engine_ResourceRequest } from '@luvio/engine';
import { RecordRepresentation as types_RecordRepresentation_RecordRepresentation } from '../types/RecordRepresentation';
export interface ResourceRequestConfig {
    urlParams: {
        recordId: string;
    };
    queryParams: {
        handleOwnerChange?: boolean;
        triggerOtherEmail?: boolean;
        triggerUserEmail?: boolean;
        useDefaultRule?: boolean;
    };
    body: {
        allowSaveOnDuplicate?: boolean;
        apiName?: string;
        fields: {
            [key: string]: string | number | null | boolean;
        };
    };
    headers: {
        ifUnmodifiedSince?: string;
    };
}
export declare function select(luvio: $64$luvio_engine_Luvio, params: ResourceRequestConfig): $64$luvio_engine_Fragment;
export declare function getResponseCacheKeys(storeKeyMap: any, luvio: $64$luvio_engine_Luvio, resourceParams: ResourceRequestConfig, response: types_RecordRepresentation_RecordRepresentation): void;
export declare function ingestSuccess(luvio: $64$luvio_engine_Luvio, resourceParams: ResourceRequestConfig, response: $64$luvio_engine_FetchResponse<types_RecordRepresentation_RecordRepresentation>): $64$luvio_engine_FulfilledSnapshot<types_RecordRepresentation_RecordRepresentation, {}> | $64$luvio_engine_StaleSnapshot<types_RecordRepresentation_RecordRepresentation, {}> | $64$luvio_engine_PendingSnapshot<types_RecordRepresentation_RecordRepresentation, any>;
export declare function createResourceRequest(config: ResourceRequestConfig): $64$luvio_engine_ResourceRequest;
export default createResourceRequest;
