import { PaginationParams as pagination_syntheticCursor_PaginationParams } from '../pagination/syntheticCursor';
import { Luvio as $64$luvio_engine_Luvio, Fragment as $64$luvio_engine_Fragment, NormalizedKeyMetadata as $64$luvio_engine_NormalizedKeyMetadata, FetchResponse as $64$luvio_engine_FetchResponse, SnapshotRefresh as $64$luvio_engine_SnapshotRefresh, FulfilledSnapshot as $64$luvio_engine_FulfilledSnapshot, StaleSnapshot as $64$luvio_engine_StaleSnapshot, PendingSnapshot as $64$luvio_engine_PendingSnapshot, ErrorResponse as $64$luvio_engine_ErrorResponse, ErrorSnapshot as $64$luvio_engine_ErrorSnapshot, ResourceRequest as $64$luvio_engine_ResourceRequest } from '@luvio/engine';
import { RelatedListRecordCollectionRepresentation as types_RelatedListRecordCollectionRepresentation_RelatedListRecordCollectionRepresentation } from '../types/RelatedListRecordCollectionRepresentation';
export interface ResourceRequestConfig {
    urlParams: {
        parentRecordId: string;
        relatedListId: string;
    };
    body: {
        fields?: Array<string>;
        optionalFields?: Array<string>;
        pageSize?: number;
        pageToken?: string;
        sortBy?: Array<string>;
        where?: string;
    };
}
export declare function createPaginationParams(params: ResourceRequestConfig): pagination_syntheticCursor_PaginationParams;
export declare function select(luvio: $64$luvio_engine_Luvio, params: ResourceRequestConfig): $64$luvio_engine_Fragment;
export declare function keyBuilder(luvio: $64$luvio_engine_Luvio, params: ResourceRequestConfig): string;
export declare function keyBuilder_StructuredKey(luvio: $64$luvio_engine_Luvio, params: ResourceRequestConfig): $64$luvio_engine_NormalizedKeyMetadata;
export declare function getResponseCacheKeys(storeKeyMap: any, luvio: $64$luvio_engine_Luvio, resourceParams: ResourceRequestConfig, response: types_RelatedListRecordCollectionRepresentation_RelatedListRecordCollectionRepresentation): void;
export declare function ingestSuccess(luvio: $64$luvio_engine_Luvio, resourceParams: ResourceRequestConfig, response: $64$luvio_engine_FetchResponse<types_RelatedListRecordCollectionRepresentation_RelatedListRecordCollectionRepresentation>, snapshotRefresh?: $64$luvio_engine_SnapshotRefresh<types_RelatedListRecordCollectionRepresentation_RelatedListRecordCollectionRepresentation>): $64$luvio_engine_FulfilledSnapshot<types_RelatedListRecordCollectionRepresentation_RelatedListRecordCollectionRepresentation, {}> | $64$luvio_engine_StaleSnapshot<types_RelatedListRecordCollectionRepresentation_RelatedListRecordCollectionRepresentation, {}> | $64$luvio_engine_PendingSnapshot<types_RelatedListRecordCollectionRepresentation_RelatedListRecordCollectionRepresentation, any>;
export declare function ingestError(luvio: $64$luvio_engine_Luvio, params: ResourceRequestConfig, error: $64$luvio_engine_ErrorResponse, snapshotRefresh?: $64$luvio_engine_SnapshotRefresh<types_RelatedListRecordCollectionRepresentation_RelatedListRecordCollectionRepresentation>): $64$luvio_engine_ErrorSnapshot;
export declare function createResourceRequest(config: ResourceRequestConfig): $64$luvio_engine_ResourceRequest;
export default createResourceRequest;
