import { KeyMetadata as $64$luvio_engine_KeyMetadata, NormalizedKeyMetadata as $64$luvio_engine_NormalizedKeyMetadata, Luvio as $64$luvio_engine_Luvio, IngestPath as $64$luvio_engine_IngestPath, Store as $64$luvio_engine_Store, FragmentUnionSelection as $64$luvio_engine_FragmentUnionSelection, FragmentSelection as $64$luvio_engine_FragmentSelection, ResourceIngest as $64$luvio_engine_ResourceIngest, DurableStoreKeyMetadataMap as $64$luvio_engine_DurableStoreKeyMetadataMap } from '@luvio/engine';
export declare enum DiscriminatorValues {
    Photo = "Photo",
    Theme = "Theme"
}
export declare const VERSION = "bc05f8d1c708b6c41c9bf2fe6001aff0";
export declare function validate(obj: any, path?: string): TypeError | null;
export declare const RepresentationType: string;
export interface KeyParams extends $64$luvio_engine_KeyMetadata {
    recordId: string;
}
export type AbstractRecordAvatarRepresentationNormalizedKeyMetadata = KeyParams & $64$luvio_engine_NormalizedKeyMetadata;
export type PartialAbstractRecordAvatarRepresentationNormalizedKeyMetadata = Partial<KeyParams> & $64$luvio_engine_NormalizedKeyMetadata;
export declare function keyBuilder(luvio: $64$luvio_engine_Luvio, config: KeyParams): string;
export declare function keyBuilder_StructuredKey(luvio: $64$luvio_engine_Luvio, config: KeyParams): AbstractRecordAvatarRepresentationNormalizedKeyMetadata;
export declare function keyBuilderFromType(luvio: $64$luvio_engine_Luvio, object: AbstractRecordAvatarRepresentation): string;
export declare function keyBuilderFromType_StructuredKey(luvio: $64$luvio_engine_Luvio, object: AbstractRecordAvatarRepresentation): $64$luvio_engine_NormalizedKeyMetadata;
export declare function normalize(input: AbstractRecordAvatarRepresentation, existing: AbstractRecordAvatarRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number): AbstractRecordAvatarRepresentationNormalized;
export declare const selectChildren: () => $64$luvio_engine_FragmentUnionSelection;
export declare const select: () => $64$luvio_engine_FragmentSelection;
export declare function equals(existing: AbstractRecordAvatarRepresentationNormalized, incoming: AbstractRecordAvatarRepresentationNormalized): boolean;
export declare const ingest: $64$luvio_engine_ResourceIngest;
export declare const discriminatorIngest: $64$luvio_engine_ResourceIngest;
export declare function getTypeCacheKeys(rootKeySet: $64$luvio_engine_DurableStoreKeyMetadataMap, luvio: $64$luvio_engine_Luvio, input: AbstractRecordAvatarRepresentation, fullPathFactory: () => string | $64$luvio_engine_NormalizedKeyMetadata): void;
/**
 * Represents an avatar associated to a record.
 *
 * Keys:
 *    recordId (string): recordId
 */
export interface AbstractRecordAvatarRepresentationNormalized {
    /** The ID of the record that this avatar is associated to. */
    recordId: string;
    /** Indicates the type of record avatar. */
    type: string;
}
/**
 * Represents an avatar associated to a record.
 *
 * Keys:
 *    recordId (string): recordId
 */
export interface AbstractRecordAvatarRepresentation {
    recordId: string;
    type: string;
}
