import { IngestPath as $64$luvio_engine_IngestPath, Luvio as $64$luvio_engine_Luvio, Store as $64$luvio_engine_Store, ResourceIngest as $64$luvio_engine_ResourceIngest, FragmentSelection as $64$luvio_engine_FragmentSelection, PathSelection as $64$luvio_engine_PathSelection, StoreLink as $64$luvio_engine_StoreLink, DurableStoreKeyMetadataMap as $64$luvio_engine_DurableStoreKeyMetadataMap, NormalizedKeyMetadata as $64$luvio_engine_NormalizedKeyMetadata } from '@luvio/engine';
import { EntityActionRepresentation as EntityActionRepresentation_EntityActionRepresentation } from './EntityActionRepresentation';
export declare const TTL = 300000;
export declare const VERSION = "e485d96c1402a9ca2f56e56485af0216";
export declare function validate(obj: any, path?: string): TypeError | null;
export declare const RepresentationType: string;
export declare function normalize(input: ActionRepresentation, existing: ActionRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number): ActionRepresentationNormalized;
export interface DynamicIngestParams {
    actions: $64$luvio_engine_ResourceIngest;
}
export declare function dynamicNormalize(ingestParams: DynamicIngestParams): (input: ActionRepresentation, existing: ActionRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number) => ActionRepresentationNormalized;
export declare const select: () => $64$luvio_engine_FragmentSelection;
export interface DynamicSelectParams {
    actions?: $64$luvio_engine_PathSelection;
}
export declare const dynamicSelect: (params: DynamicSelectParams) => $64$luvio_engine_FragmentSelection;
export declare function equals(existing: ActionRepresentationNormalized, incoming: ActionRepresentationNormalized): boolean;
export declare const ingest: $64$luvio_engine_ResourceIngest;
export declare function getTypeCacheKeys(rootKeySet: $64$luvio_engine_DurableStoreKeyMetadataMap, luvio: $64$luvio_engine_Luvio, input: ActionRepresentation, fullPathFactory: () => string | $64$luvio_engine_NormalizedKeyMetadata): void;
export declare function dynamicIngest(ingestParams: DynamicIngestParams): $64$luvio_engine_ResourceIngest;
/**
 * Actions.
 *
 * Keys:
 *    (none)
 */
export interface ActionRepresentationNormalized {
    /** Record data with some metatdata. */
    actions: {
        [key: string]: $64$luvio_engine_StoreLink;
    };
    /** ETag like field, readOnly, handy while caching. */
    eTag: string;
    /** the url of the current request */
    url: string;
}
/**
 * Actions.
 *
 * Keys:
 *    (none)
 */
export interface ActionRepresentation {
    actions: {
        [key: string]: EntityActionRepresentation_EntityActionRepresentation;
    };
    eTag: string;
    url: string;
}
