import { KeyMetadata as $64$luvio_engine_KeyMetadata, NormalizedKeyMetadata as $64$luvio_engine_NormalizedKeyMetadata, Luvio as $64$luvio_engine_Luvio, IngestPath as $64$luvio_engine_IngestPath, Store as $64$luvio_engine_Store, ResourceIngest as $64$luvio_engine_ResourceIngest, FragmentSelection as $64$luvio_engine_FragmentSelection, LinkSelection as $64$luvio_engine_LinkSelection, StoreLink as $64$luvio_engine_StoreLink, DurableStoreKeyMetadataMap as $64$luvio_engine_DurableStoreKeyMetadataMap } from '@luvio/engine';
import { NavItemRepresentation as NavItemRepresentation_NavItemRepresentation } from './NavItemRepresentation';
export declare const TTL = 300000;
export declare const VERSION = "0cd492fdd6c713c206ef53dc02175f71";
export declare function validate(obj: any, path?: string): TypeError | null;
export declare const RepresentationType: string;
export interface KeyParams extends $64$luvio_engine_KeyMetadata {
    appId: string | null;
}
export type AppRepresentationNormalizedKeyMetadata = KeyParams & $64$luvio_engine_NormalizedKeyMetadata;
export type PartialAppRepresentationNormalizedKeyMetadata = Partial<KeyParams> & $64$luvio_engine_NormalizedKeyMetadata;
export declare function keyBuilder(luvio: $64$luvio_engine_Luvio, config: KeyParams): string;
export declare function keyBuilder_StructuredKey(luvio: $64$luvio_engine_Luvio, config: KeyParams): AppRepresentationNormalizedKeyMetadata;
export declare function keyBuilderFromType(luvio: $64$luvio_engine_Luvio, object: AppRepresentation): string;
export declare function keyBuilderFromType_StructuredKey(luvio: $64$luvio_engine_Luvio, object: AppRepresentation): $64$luvio_engine_NormalizedKeyMetadata;
export declare function normalize(input: AppRepresentation, existing: AppRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number): AppRepresentationNormalized;
export interface DynamicIngestParams {
    navItems: $64$luvio_engine_ResourceIngest;
    userNavItems: $64$luvio_engine_ResourceIngest;
}
export declare function dynamicNormalize(ingestParams: DynamicIngestParams): (input: AppRepresentation, existing: AppRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number) => AppRepresentationNormalized;
export declare const select: () => $64$luvio_engine_FragmentSelection;
export interface DynamicSelectParams {
    navItems?: $64$luvio_engine_LinkSelection;
    userNavItems?: $64$luvio_engine_LinkSelection;
}
export declare const dynamicSelect: (params: DynamicSelectParams) => $64$luvio_engine_FragmentSelection;
export declare function equals(existing: AppRepresentationNormalized, incoming: AppRepresentationNormalized): boolean;
export declare const ingest: $64$luvio_engine_ResourceIngest;
export declare function getTypeCacheKeys(rootKeySet: $64$luvio_engine_DurableStoreKeyMetadataMap, luvio: $64$luvio_engine_Luvio, input: AppRepresentation, fullPathFactory: () => string | $64$luvio_engine_NormalizedKeyMetadata): void;
export declare function dynamicIngest(ingestParams: DynamicIngestParams): $64$luvio_engine_ResourceIngest;
/**
 * Metadata for an app
 *
 * Keys:
 *    appId (string | null): appId
 */
export interface AppRepresentationNormalized {
    /** Reference to App Definition */
    appId: string | null;
    /** Description for the app */
    description: string | null;
    /** Unique developer name of the app */
    developerName: string;
    /** ETag like field, readOnly, handy while caching. */
    eTag: string;
    /** Device form factors in which this app is supported */
    formFactors: Array<string>;
    /** Primary color selected by admin for this app. Ex: #0070D2 */
    headerColor: string | null;
    /** Icon URL of the App */
    iconUrl: string | null;
    /** Nav automatically create temporary tabs setting */
    isNavAutoTempTabsDisabled: boolean;
    /** Nav personalization setting */
    isNavPersonalizationDisabled: boolean;
    /** Indicates if the Lightning Console App should persist a user's workspace tabs */
    isNavTabPersistenceDisabled: boolean;
    /** Indicates if the Lightning App should contain the Omni-Channel pinned view */
    isOmniPinnedViewEnabled: boolean;
    /** Label of the app */
    label: string;
    /** URL of the logo uploaded by Admin for this app */
    logoUrl: string;
    /** Mobile specific launch url for this app */
    mobileStartUrl: string | null;
    /** tabs/nav items for the app */
    navItems: Array<$64$luvio_engine_StoreLink>;
    /** Flag to specify if this app is the default app for the user */
    selected: boolean;
    /** Launch URL for this app */
    startUrl: string;
    /** Type of the app - Classic/Lightning/Community/Connected */
    type: string;
    /** User's nav items for the app, if applicable and requested. */
    userNavItems: Array<$64$luvio_engine_StoreLink>;
}
/**
 * Metadata for an app
 *
 * Keys:
 *    appId (string | null): appId
 */
export interface AppRepresentation {
    appId: string | null;
    description: string | null;
    developerName: string;
    eTag: string;
    formFactors: Array<string>;
    headerColor: string | null;
    iconUrl: string | null;
    isNavAutoTempTabsDisabled: boolean;
    isNavPersonalizationDisabled: boolean;
    isNavTabPersistenceDisabled: boolean;
    isOmniPinnedViewEnabled: boolean;
    label: string;
    logoUrl: string;
    mobileStartUrl: string | null;
    navItems: Array<NavItemRepresentation_NavItemRepresentation>;
    selected: boolean;
    startUrl: string;
    type: string;
    userNavItems: Array<NavItemRepresentation_NavItemRepresentation>;
}
