import { DuplicateRuleRepresentation as DuplicateRuleRepresentation_DuplicateRuleRepresentation } from './DuplicateRuleRepresentation';
import { IngestPath as $64$luvio_engine_IngestPath, Luvio as $64$luvio_engine_Luvio, Store as $64$luvio_engine_Store, FragmentSelection as $64$luvio_engine_FragmentSelection, ResourceIngest as $64$luvio_engine_ResourceIngest, DurableStoreKeyMetadataMap as $64$luvio_engine_DurableStoreKeyMetadataMap, NormalizedKeyMetadata as $64$luvio_engine_NormalizedKeyMetadata } from '@luvio/engine';
export declare const TTL = 900000;
export declare const VERSION = "be27ee99dc0dc43a1f66b8fe98dc532c";
export declare function validate(obj: any, path?: string): TypeError | null;
export declare const RepresentationType: string;
export declare function normalize(input: DuplicatesConfigurationRepresentation, existing: DuplicatesConfigurationRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number): DuplicatesConfigurationRepresentationNormalized;
export declare const select: () => $64$luvio_engine_FragmentSelection;
export declare function equals(existing: DuplicatesConfigurationRepresentationNormalized, incoming: DuplicatesConfigurationRepresentationNormalized): boolean;
export declare const ingest: $64$luvio_engine_ResourceIngest;
export declare function getTypeCacheKeys(rootKeySet: $64$luvio_engine_DurableStoreKeyMetadataMap, luvio: $64$luvio_engine_Luvio, input: DuplicatesConfigurationRepresentation, fullPathFactory: () => string | $64$luvio_engine_NormalizedKeyMetadata): void;
/**
 * Duplicate Configuration for an object API.
 *
 * Keys:
 *    (none)
 */
export interface DuplicatesConfigurationRepresentationNormalized {
    /** ApiName of the Entity. */
    apiName: string;
    /** Determine dedupe is enabled/disabled */
    dedupeEnabled: boolean;
    /** Dedupe fields used in config. */
    dedupeFields: Array<string>;
    /** Duplicate rules used in dedupe config. */
    duplicateRules: Array<DuplicateRuleRepresentation_DuplicateRuleRepresentation>;
    /** ETag like field, readOnly, handy while caching. */
    eTag: string;
    /** Determine predupe is enabled/disabled. */
    predupeEnabled: boolean;
}
/**
 * Duplicate Configuration for an object API.
 *
 * Keys:
 *    (none)
 */
export interface DuplicatesConfigurationRepresentation {
    apiName: string;
    dedupeEnabled: boolean;
    dedupeFields: Array<string>;
    duplicateRules: Array<DuplicateRuleRepresentation_DuplicateRuleRepresentation>;
    eTag: string;
    predupeEnabled: boolean;
}
