import { MatchRepresentation as MatchRepresentation_MatchRepresentation } from './MatchRepresentation';
import { IngestPath as $64$luvio_engine_IngestPath, Luvio as $64$luvio_engine_Luvio, Store as $64$luvio_engine_Store, BaseFragment as $64$luvio_engine_BaseFragment, ResourceIngest as $64$luvio_engine_ResourceIngest, DurableStoreKeyMetadataMap as $64$luvio_engine_DurableStoreKeyMetadataMap, NormalizedKeyMetadata as $64$luvio_engine_NormalizedKeyMetadata } from '@luvio/engine';
export declare const TTL = 30000;
export declare const VERSION = "583c38564fa15ce0fb3dd2807be1bdc6";
export declare function validate(obj: any, path?: string): TypeError | null;
export declare const RepresentationType: string;
export declare function normalize(input: DuplicatesRepresentation, existing: DuplicatesRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number): DuplicatesRepresentationNormalized;
export declare const select: () => $64$luvio_engine_BaseFragment;
export declare function equals(existing: DuplicatesRepresentationNormalized, incoming: DuplicatesRepresentationNormalized): boolean;
export declare const ingest: $64$luvio_engine_ResourceIngest;
export declare function getTypeCacheKeys(rootKeySet: $64$luvio_engine_DurableStoreKeyMetadataMap, luvio: $64$luvio_engine_Luvio, input: DuplicatesRepresentation, fullPathFactory: () => string | $64$luvio_engine_NormalizedKeyMetadata): void;
/**
 * Duplicates
 *
 * Keys:
 *    (none)
 */
export interface DuplicatesRepresentationNormalized {
    /** Determince whether duplicates are allowed to be saved */
    allowSave: boolean;
    /** Determine if there  exists duplicates. */
    duplicateError: boolean;
    /** Duplicate rules used for match. */
    duplicateRules: Array<string>;
    /** A list of potential matches. */
    matches: Array<MatchRepresentation_MatchRepresentation>;
}
/**
 * Duplicates
 *
 * Keys:
 *    (none)
 */
export interface DuplicatesRepresentation {
    allowSave: boolean;
    duplicateError: boolean;
    duplicateRules: Array<string>;
    matches: Array<MatchRepresentation_MatchRepresentation>;
}
