import { FormSectionRepresentation as FormSectionRepresentation_FormSectionRepresentation } from './FormSectionRepresentation';
import { IngestPath as $64$luvio_engine_IngestPath, Luvio as $64$luvio_engine_Luvio, Store as $64$luvio_engine_Store, FragmentSelection as $64$luvio_engine_FragmentSelection, ResourceIngest as $64$luvio_engine_ResourceIngest, DurableStoreKeyMetadataMap as $64$luvio_engine_DurableStoreKeyMetadataMap, NormalizedKeyMetadata as $64$luvio_engine_NormalizedKeyMetadata } from '@luvio/engine';
export declare const VERSION = "8859d745b02b587de3df527233250e0e";
export declare function validate(obj: any, path?: string): TypeError | null;
export declare const RepresentationType: string;
export declare function normalize(input: FormRepresentation, existing: FormRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number): FormRepresentationNormalized;
export declare const select: () => $64$luvio_engine_FragmentSelection;
export declare function equals(existing: FormRepresentationNormalized, incoming: FormRepresentationNormalized): boolean;
export declare const ingest: $64$luvio_engine_ResourceIngest;
export declare function getTypeCacheKeys(rootKeySet: $64$luvio_engine_DurableStoreKeyMetadataMap, luvio: $64$luvio_engine_Luvio, input: FormRepresentation, fullPathFactory: () => string | $64$luvio_engine_NormalizedKeyMetadata): void;
/**
 * Form.
 *
 * Keys:
 *    (none)
 */
export interface FormRepresentationNormalized {
    /** Form developer name. */
    apiName: string;
    /** ETag like field, readOnly, handy while caching. */
    eTag: string;
    /** Form label. */
    label: string;
    /** Form sections. */
    sections: Array<FormSectionRepresentation_FormSectionRepresentation>;
}
/**
 * Form.
 *
 * Keys:
 *    (none)
 */
export interface FormRepresentation {
    apiName: string;
    eTag: string;
    label: string;
    sections: Array<FormSectionRepresentation_FormSectionRepresentation>;
}
