import { GraphQLErrorLocation as GraphQLErrorLocation_GraphQLErrorLocation } from './GraphQLErrorLocation';
import { IngestPath as $64$luvio_engine_IngestPath, Luvio as $64$luvio_engine_Luvio, Store as $64$luvio_engine_Store, FragmentSelection as $64$luvio_engine_FragmentSelection, ResourceIngest as $64$luvio_engine_ResourceIngest, DurableStoreKeyMetadataMap as $64$luvio_engine_DurableStoreKeyMetadataMap, NormalizedKeyMetadata as $64$luvio_engine_NormalizedKeyMetadata } from '@luvio/engine';
export declare const VERSION = "fed2a1b51b8fbea92b53e5e0d0408fa4";
export declare function validate(obj: any, path?: string): TypeError | null;
export declare const RepresentationType: string;
export declare function normalize(input: GraphQLErrorRepresentation, existing: GraphQLErrorRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number): GraphQLErrorRepresentationNormalized;
export declare const select: () => $64$luvio_engine_FragmentSelection;
export declare function equals(existing: GraphQLErrorRepresentationNormalized, incoming: GraphQLErrorRepresentationNormalized): boolean;
export declare const ingest: $64$luvio_engine_ResourceIngest;
export declare function getTypeCacheKeys(rootKeySet: $64$luvio_engine_DurableStoreKeyMetadataMap, luvio: $64$luvio_engine_Luvio, input: GraphQLErrorRepresentation, fullPathFactory: () => string | $64$luvio_engine_NormalizedKeyMetadata): void;
/**
 * A GraphQL Error.
 *
 * Keys:
 *    (none)
 */
export interface GraphQLErrorRepresentationNormalized {
    /** The extensions of the error occurred. */
    extensions: {
        [key: string]: {};
    };
    /** The locations where the error occurred. */
    locations: Array<GraphQLErrorLocation_GraphQLErrorLocation>;
    /** The reason the error occurred. */
    message: string;
    /** The paths where the error occurred. */
    paths: Array<{}>;
}
/**
 * A GraphQL Error.
 *
 * Keys:
 *    (none)
 */
export interface GraphQLErrorRepresentation {
    extensions: {
        [key: string]: {};
    };
    locations: Array<GraphQLErrorLocation_GraphQLErrorLocation>;
    message: string;
    paths: Array<{}>;
}
