import { ListColumnInlineEditAttributesRepresentationWrapper as ListColumnInlineEditAttributesRepresentationWrapper_ListColumnInlineEditAttributesRepresentationWrapper } from './ListColumnInlineEditAttributesRepresentationWrapper';
import { IngestPath as $64$luvio_engine_IngestPath, Luvio as $64$luvio_engine_Luvio, Store as $64$luvio_engine_Store, BaseFragment as $64$luvio_engine_BaseFragment, ResourceIngest as $64$luvio_engine_ResourceIngest, DurableStoreKeyMetadataMap as $64$luvio_engine_DurableStoreKeyMetadataMap, NormalizedKeyMetadata as $64$luvio_engine_NormalizedKeyMetadata } from '@luvio/engine';
export declare const VERSION = "64e2cac6d374ad92f491a9f8a952c6c3";
export declare function validate(obj: any, path?: string): TypeError | null;
export declare const RepresentationType: string;
export declare function normalize(input: ListColumnRepresentation, existing: ListColumnRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number): ListColumnRepresentationNormalized;
export declare const select: () => $64$luvio_engine_BaseFragment;
export declare function equals(existing: ListColumnRepresentationNormalized, incoming: ListColumnRepresentationNormalized): boolean;
export declare const ingest: $64$luvio_engine_ResourceIngest;
export declare function getTypeCacheKeys(rootKeySet: $64$luvio_engine_DurableStoreKeyMetadataMap, luvio: $64$luvio_engine_Luvio, input: ListColumnRepresentation, fullPathFactory: () => string | $64$luvio_engine_NormalizedKeyMetadata): void;
/**
 * ListColumnRepresentation
 *
 * Keys:
 *    (none)
 */
export interface ListColumnRepresentationNormalized {
    /** API name for the field. */
    fieldApiName: string;
    /** Map of RecordTypeId -> inline edit attributes. */
    inlineEditAttributes: ListColumnInlineEditAttributesRepresentationWrapper_ListColumnInlineEditAttributesRepresentationWrapper | null;
    /** Label of the field. */
    label: string;
    /** The lookupId for the column when the field is a reference, otherwise null. */
    lookupId: string | null;
    /** Whether the list column is searchable. */
    searchable: boolean;
    /** Whether the list column is sortable. */
    sortable: boolean;
}
/**
 * ListColumnRepresentation
 *
 * Keys:
 *    (none)
 */
export interface ListColumnRepresentation {
    fieldApiName: string;
    inlineEditAttributes: ListColumnInlineEditAttributesRepresentationWrapper_ListColumnInlineEditAttributesRepresentationWrapper | null;
    label: string;
    lookupId: string | null;
    searchable: boolean;
    sortable: boolean;
}
