import { ListFilterByInfoRepresentation as ListFilterByInfoRepresentation_ListFilterByInfoRepresentation } from './ListFilterByInfoRepresentation';
import { ListInlineEditDetailsRepresentation as ListInlineEditDetailsRepresentation_ListInlineEditDetailsRepresentation } from './ListInlineEditDetailsRepresentation';
import { ListReferenceRepresentation as ListReferenceRepresentation_ListReferenceRepresentation } from './ListReferenceRepresentation';
import { ListInfoShareCategoryRepresentation as ListInfoShareCategoryRepresentation_ListInfoShareCategoryRepresentation } from './ListInfoShareCategoryRepresentation';
import { ListOrderByInfoRepresentation as ListOrderByInfoRepresentation_ListOrderByInfoRepresentation } from './ListOrderByInfoRepresentation';
import { ListScopeRepresentation as ListScopeRepresentation_ListScopeRepresentation } from './ListScopeRepresentation';
import { ListUserPreferenceRepresentation as ListUserPreferenceRepresentation_ListUserPreferenceRepresentation } from './ListUserPreferenceRepresentation';
import { KeyMetadata as $64$luvio_engine_KeyMetadata, NormalizedKeyMetadata as $64$luvio_engine_NormalizedKeyMetadata, Luvio as $64$luvio_engine_Luvio, IngestPath as $64$luvio_engine_IngestPath, Store as $64$luvio_engine_Store, ResourceIngest as $64$luvio_engine_ResourceIngest, FragmentSelection as $64$luvio_engine_FragmentSelection, LinkSelection as $64$luvio_engine_LinkSelection, StoreLink as $64$luvio_engine_StoreLink, DurableStoreKeyMetadataMap as $64$luvio_engine_DurableStoreKeyMetadataMap } from '@luvio/engine';
import { ListColumnRepresentation as ListColumnRepresentation_ListColumnRepresentation } from './ListColumnRepresentation';
export declare const TTL = 900000;
export declare const VERSION = "5adf17d38be03c0f71b1c52485b377a6";
export declare function validate(obj: any, path?: string): TypeError | null;
export declare const RepresentationType: string;
export interface KeyParams extends $64$luvio_engine_KeyMetadata {
    listViewApiName: string | null;
    objectApiName: string;
    type: string;
}
export type ListInfoRepresentationNormalizedKeyMetadata = KeyParams & $64$luvio_engine_NormalizedKeyMetadata;
export type PartialListInfoRepresentationNormalizedKeyMetadata = Partial<KeyParams> & $64$luvio_engine_NormalizedKeyMetadata;
export declare function keyBuilder(luvio: $64$luvio_engine_Luvio, config: KeyParams): string;
export declare function keyBuilder_StructuredKey(luvio: $64$luvio_engine_Luvio, config: KeyParams): ListInfoRepresentationNormalizedKeyMetadata;
export declare function keyBuilderFromType(luvio: $64$luvio_engine_Luvio, object: ListInfoRepresentation): string;
export declare function keyBuilderFromType_StructuredKey(luvio: $64$luvio_engine_Luvio, object: ListInfoRepresentation): $64$luvio_engine_NormalizedKeyMetadata;
export declare function normalize(input: ListInfoRepresentation, existing: ListInfoRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number): ListInfoRepresentationNormalized;
export interface DynamicIngestParams {
    displayColumns: $64$luvio_engine_ResourceIngest;
}
export declare function dynamicNormalize(ingestParams: DynamicIngestParams): (input: ListInfoRepresentation, existing: ListInfoRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number) => ListInfoRepresentationNormalized;
export declare const select: () => $64$luvio_engine_FragmentSelection;
export interface DynamicSelectParams {
    displayColumns?: $64$luvio_engine_LinkSelection;
}
export declare const dynamicSelect: (params: DynamicSelectParams) => $64$luvio_engine_FragmentSelection;
export declare function equals(existing: ListInfoRepresentationNormalized, incoming: ListInfoRepresentationNormalized): boolean;
export declare const ingest: $64$luvio_engine_ResourceIngest;
export declare function getTypeCacheKeys(rootKeySet: $64$luvio_engine_DurableStoreKeyMetadataMap, luvio: $64$luvio_engine_Luvio, input: ListInfoRepresentation, fullPathFactory: () => string | $64$luvio_engine_NormalizedKeyMetadata): void;
export declare function dynamicIngest(ingestParams: DynamicIngestParams): $64$luvio_engine_ResourceIngest;
/**
 * ListInfoRepresentation
 *
 * Keys:
 *    listViewApiName (string | null): listReference.listViewApiName
 *    objectApiName (string): listReference.objectApiName
 *    type (string): listReference.type
 */
export interface ListInfoRepresentationNormalized {
    /** Indicates whether the listview can be cloned. */
    cloneable: boolean;
    /** Indicates whether a new listview for this listview's SObject can be created. */
    createable: boolean;
    /** Indicates whether the listview can be deleted. */
    deletable: boolean;
    /** All display columns for this list view. */
    displayColumns: Array<$64$luvio_engine_StoreLink>;
    /** ETag like field, readOnly, handy while caching. */
    eTag: string;
    /** This is the filter logic such as "(1 OR 2) and 3".  Indexes are 1-based. */
    filterLogicString: string | null;
    /** Describes how the list view is filtered. */
    filteredByInfo: Array<ListFilterByInfoRepresentation_ListFilterByInfoRepresentation>;
    /** Indicates whether this listview has mass actions. */
    hasMassActions?: boolean;
    inlineEditDetails: ListInlineEditDetailsRepresentation_ListInlineEditDetailsRepresentation;
    /** The list view's display label.  E.g. "All Accounts". */
    label: string | null;
    listReference: ListReferenceRepresentation_ListReferenceRepresentation;
    /** The items a list is shared with. */
    listShares: Array<ListInfoShareCategoryRepresentation_ListInfoShareCategoryRepresentation>;
    /** The API name of any objects that are returned by this relatedList. */
    objectApiNames: Array<string>;
    /** Describes how records are ordered in this list view. */
    orderedByInfo: Array<ListOrderByInfoRepresentation_ListOrderByInfoRepresentation>;
    /** Scope information for this list view. */
    scope: ListScopeRepresentation_ListScopeRepresentation | null;
    /** Indicates whether the listview can be searched (SOSL). */
    searchable: boolean;
    /** Indicates whether the listview can be updated. */
    updateable: boolean;
    userPreferences: ListUserPreferenceRepresentation_ListUserPreferenceRepresentation;
    /** The list view's visibility. */
    visibility: string;
    /** Indicates whether the visibility of the listview can be edited. */
    visibilityEditable: boolean;
}
/**
 * ListInfoRepresentation
 *
 * Keys:
 *    listViewApiName (string | null): listReference.listViewApiName
 *    objectApiName (string): listReference.objectApiName
 *    type (string): listReference.type
 */
export interface ListInfoRepresentation {
    cloneable: boolean;
    createable: boolean;
    deletable: boolean;
    displayColumns: Array<ListColumnRepresentation_ListColumnRepresentation>;
    eTag: string;
    filterLogicString: string | null;
    filteredByInfo: Array<ListFilterByInfoRepresentation_ListFilterByInfoRepresentation>;
    hasMassActions?: boolean;
    inlineEditDetails: ListInlineEditDetailsRepresentation_ListInlineEditDetailsRepresentation;
    label: string | null;
    listReference: ListReferenceRepresentation_ListReferenceRepresentation;
    listShares: Array<ListInfoShareCategoryRepresentation_ListInfoShareCategoryRepresentation>;
    objectApiNames: Array<string>;
    orderedByInfo: Array<ListOrderByInfoRepresentation_ListOrderByInfoRepresentation>;
    scope: ListScopeRepresentation_ListScopeRepresentation | null;
    searchable: boolean;
    updateable: boolean;
    userPreferences: ListUserPreferenceRepresentation_ListUserPreferenceRepresentation;
    visibility: string;
    visibilityEditable: boolean;
}
export declare const notifyUpdateAvailableFactory: (luvio: $64$luvio_engine_Luvio) => (configs: Partial<KeyParams>[]) => Promise<void>;
