import { ListObjectPicklistValueRepresentation as ListObjectPicklistValueRepresentation_ListObjectPicklistValueRepresentation } from './ListObjectPicklistValueRepresentation';
import { ListObjectQuickFilterOverridesRepresentation as ListObjectQuickFilterOverridesRepresentation_ListObjectQuickFilterOverridesRepresentation } from './ListObjectQuickFilterOverridesRepresentation';
import { IngestPath as $64$luvio_engine_IngestPath, Luvio as $64$luvio_engine_Luvio, Store as $64$luvio_engine_Store, FragmentSelection as $64$luvio_engine_FragmentSelection, ResourceIngest as $64$luvio_engine_ResourceIngest, DurableStoreKeyMetadataMap as $64$luvio_engine_DurableStoreKeyMetadataMap, NormalizedKeyMetadata as $64$luvio_engine_NormalizedKeyMetadata } from '@luvio/engine';
export declare const VERSION = "394e8d71b515892fe366021cc2872dae";
export declare function validate(obj: any, path?: string): TypeError | null;
export declare const RepresentationType: string;
export declare function normalize(input: ListObjectColumnRepresentation, existing: ListObjectColumnRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number): ListObjectColumnRepresentationNormalized;
export declare const select: () => $64$luvio_engine_FragmentSelection;
export declare function equals(existing: ListObjectColumnRepresentationNormalized, incoming: ListObjectColumnRepresentationNormalized): boolean;
export declare const ingest: $64$luvio_engine_ResourceIngest;
export declare function getTypeCacheKeys(rootKeySet: $64$luvio_engine_DurableStoreKeyMetadataMap, luvio: $64$luvio_engine_Luvio, input: ListObjectColumnRepresentation, fullPathFactory: () => string | $64$luvio_engine_NormalizedKeyMetadata): void;
/**
 * ListObjectColumnRepresentation
 *
 * Keys:
 *    (none)
 */
export interface ListObjectColumnRepresentationNormalized {
    /** The alias for this column. */
    alias: string;
    /** The data type for this column. */
    dataType: string | null;
    /** The default filter operator for this column. */
    defaultFilterOperator: string;
    /** Whether or not this column is displayable. */
    displayable: boolean;
    /** The field API name for this column. */
    fieldApiName: string;
    /** Whether or not this column is filterable. */
    filterable: boolean;
    /** The label for this column. */
    label: string;
    /** The list of allowed picklist values for this column. */
    picklistValues: Array<ListObjectPicklistValueRepresentation_ListObjectPicklistValueRepresentation>;
    /** The operator to use for quick filters on this column. */
    quickFilterOperator: string | null;
    /** Optional overrides to use for quick filters on this column. */
    quickFilterOverrides: ListObjectQuickFilterOverridesRepresentation_ListObjectQuickFilterOverridesRepresentation | null;
    /** Whether or not this column supports quick filters. */
    quickFilterable: boolean;
    /** Whether or not this column is sortable. */
    sortable: boolean;
    /** The supported filter operators for this column. */
    supportedFilterOperators: Array<string>;
}
/**
 * ListObjectColumnRepresentation
 *
 * Keys:
 *    (none)
 */
export interface ListObjectColumnRepresentation {
    alias: string;
    dataType: string | null;
    defaultFilterOperator: string;
    displayable: boolean;
    fieldApiName: string;
    filterable: boolean;
    label: string;
    picklistValues: Array<ListObjectPicklistValueRepresentation_ListObjectPicklistValueRepresentation>;
    quickFilterOperator: string | null;
    quickFilterOverrides: ListObjectQuickFilterOverridesRepresentation_ListObjectQuickFilterOverridesRepresentation | null;
    quickFilterable: boolean;
    sortable: boolean;
    supportedFilterOperators: Array<string>;
}
