import { ListReferenceRepresentation as ListReferenceRepresentation_ListReferenceRepresentation } from './ListReferenceRepresentation';
import { ListOrderByInfoRepresentation as ListOrderByInfoRepresentation_ListOrderByInfoRepresentation } from './ListOrderByInfoRepresentation';
import { KeyMetadata as $64$luvio_engine_KeyMetadata, NormalizedKeyMetadata as $64$luvio_engine_NormalizedKeyMetadata, Luvio as $64$luvio_engine_Luvio, IngestPath as $64$luvio_engine_IngestPath, Store as $64$luvio_engine_Store, FragmentSelection as $64$luvio_engine_FragmentSelection, ResourceIngest as $64$luvio_engine_ResourceIngest, DurableStoreKeyMetadataMap as $64$luvio_engine_DurableStoreKeyMetadataMap } from '@luvio/engine';
export declare const TTL = 900000;
export declare const VERSION = "458d4a6a30201e422e8daec5fcb03845";
export declare function validate(obj: any, path?: string): TypeError | null;
export declare const RepresentationType: string;
export interface KeyParams extends $64$luvio_engine_KeyMetadata {
    objectApiName: string;
    listViewApiName: string | null;
}
export type ListPreferencesRepresentationNormalizedKeyMetadata = KeyParams & $64$luvio_engine_NormalizedKeyMetadata;
export type PartialListPreferencesRepresentationNormalizedKeyMetadata = Partial<KeyParams> & $64$luvio_engine_NormalizedKeyMetadata;
export declare function keyBuilder(luvio: $64$luvio_engine_Luvio, config: KeyParams): string;
export declare function keyBuilder_StructuredKey(luvio: $64$luvio_engine_Luvio, config: KeyParams): ListPreferencesRepresentationNormalizedKeyMetadata;
export declare function keyBuilderFromType(luvio: $64$luvio_engine_Luvio, object: ListPreferencesRepresentation): string;
export declare function keyBuilderFromType_StructuredKey(luvio: $64$luvio_engine_Luvio, object: ListPreferencesRepresentation): $64$luvio_engine_NormalizedKeyMetadata;
export declare function normalize(input: ListPreferencesRepresentation, existing: ListPreferencesRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number): ListPreferencesRepresentationNormalized;
export declare const select: () => $64$luvio_engine_FragmentSelection;
export declare function equals(existing: ListPreferencesRepresentationNormalized, incoming: ListPreferencesRepresentationNormalized): boolean;
export declare const ingest: $64$luvio_engine_ResourceIngest;
export declare function getTypeCacheKeys(rootKeySet: $64$luvio_engine_DurableStoreKeyMetadataMap, luvio: $64$luvio_engine_Luvio, input: ListPreferencesRepresentation, fullPathFactory: () => string | $64$luvio_engine_NormalizedKeyMetadata): void;
/**
 * ListPreferencesRepresentation
 *
 * Keys:
 *    objectApiName (string): listReference.objectApiName
 *    listViewApiName (string | null): listReference.listViewApiName
 */
export interface ListPreferencesRepresentationNormalized {
    /** Column width preferences for the list. */
    columnWidths: {
        [key: string]: number;
    };
    /** Column wrapping preferences for the list. */
    columnWrap: {
        [key: string]: boolean;
    };
    listReference: ListReferenceRepresentation_ListReferenceRepresentation;
    /** Ordering preference for the list. */
    orderedBy: Array<ListOrderByInfoRepresentation_ListOrderByInfoRepresentation>;
}
/**
 * ListPreferencesRepresentation
 *
 * Keys:
 *    objectApiName (string): listReference.objectApiName
 *    listViewApiName (string | null): listReference.listViewApiName
 */
export interface ListPreferencesRepresentation {
    columnWidths: {
        [key: string]: number;
    };
    columnWrap: {
        [key: string]: boolean;
    };
    listReference: ListReferenceRepresentation_ListReferenceRepresentation;
    orderedBy: Array<ListOrderByInfoRepresentation_ListOrderByInfoRepresentation>;
}
