import { IngestPath as $64$luvio_engine_IngestPath, Luvio as $64$luvio_engine_Luvio, Store as $64$luvio_engine_Store, FragmentSelection as $64$luvio_engine_FragmentSelection, ResourceIngest as $64$luvio_engine_ResourceIngest, DurableStoreKeyMetadataMap as $64$luvio_engine_DurableStoreKeyMetadataMap, NormalizedKeyMetadata as $64$luvio_engine_NormalizedKeyMetadata } from '@luvio/engine';
export declare const TTL = 900000;
export declare const VERSION = "b47b44e260e5ce777beaf3da9088997c";
export declare function validate(obj: any, path?: string): TypeError | null;
export declare const RepresentationType: string;
export declare function normalize(input: MatchRuleRepresentation, existing: MatchRuleRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number): MatchRuleRepresentationNormalized;
export declare const select: () => $64$luvio_engine_FragmentSelection;
export declare function equals(existing: MatchRuleRepresentationNormalized, incoming: MatchRuleRepresentationNormalized): boolean;
export declare const ingest: $64$luvio_engine_ResourceIngest;
export declare function getTypeCacheKeys(rootKeySet: $64$luvio_engine_DurableStoreKeyMetadataMap, luvio: $64$luvio_engine_Luvio, input: MatchRuleRepresentation, fullPathFactory: () => string | $64$luvio_engine_NormalizedKeyMetadata): void;
/**
 * Match Rule for dedupe configuration
 *
 * Keys:
 *    (none)
 */
export interface MatchRuleRepresentationNormalized {
    /** ETag like field, readOnly, handy while caching. */
    eTag: string;
    /** Name of Matching Engine. */
    matchEngine: string;
    /** Fields used for current MatchRule. */
    matchFields: Array<string>;
    /** Name of the current MatchRule. */
    name: string;
    /** Entity Type of Match Rule. */
    objectApiName: string;
}
/**
 * Match Rule for dedupe configuration
 *
 * Keys:
 *    (none)
 */
export interface MatchRuleRepresentation {
    eTag: string;
    matchEngine: string;
    matchFields: Array<string>;
    name: string;
    objectApiName: string;
}
