import { keyBuilder as AbstractRecordAvatarRepresentation_keyBuilder, AbstractRecordAvatarRepresentation as AbstractRecordAvatarRepresentation_AbstractRecordAvatarRepresentation } from './AbstractRecordAvatarRepresentation';
import { PhotoMetadataRepresentation as PhotoMetadataRepresentation_PhotoMetadataRepresentation } from './PhotoMetadataRepresentation';
import { Luvio as $64$luvio_engine_Luvio, NormalizedKeyMetadata as $64$luvio_engine_NormalizedKeyMetadata, IngestPath as $64$luvio_engine_IngestPath, Store as $64$luvio_engine_Store, FragmentSelection as $64$luvio_engine_FragmentSelection, ResourceIngest as $64$luvio_engine_ResourceIngest, DurableStoreKeyMetadataMap as $64$luvio_engine_DurableStoreKeyMetadataMap } from '@luvio/engine';
export declare const VERSION = "34ffbf4219dfebb707bff609c2d5bf89";
export declare function validate(obj: any, path?: string): TypeError | null;
export declare const RepresentationType: string;
export declare function keyBuilder(luvio: $64$luvio_engine_Luvio, config: Parameters<typeof AbstractRecordAvatarRepresentation_keyBuilder>[1]): string;
export declare function keyBuilderFromType(luvio: $64$luvio_engine_Luvio, object: AbstractRecordAvatarRepresentation_AbstractRecordAvatarRepresentation): string;
export declare function keyBuilder_StructuredKey(luvio: $64$luvio_engine_Luvio, config: Parameters<typeof AbstractRecordAvatarRepresentation_keyBuilder>[1]): $64$luvio_engine_NormalizedKeyMetadata;
export declare function keyBuilderFromType_StructuredKey(luvio: $64$luvio_engine_Luvio, object: AbstractRecordAvatarRepresentation_AbstractRecordAvatarRepresentation): $64$luvio_engine_NormalizedKeyMetadata;
export declare function normalize(input: PhotoRecordAvatarRepresentation, existing: PhotoRecordAvatarRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number): PhotoRecordAvatarRepresentationNormalized;
export declare const select: () => $64$luvio_engine_FragmentSelection;
export declare function equals(existing: PhotoRecordAvatarRepresentationNormalized, incoming: PhotoRecordAvatarRepresentationNormalized): boolean;
export declare const ingest: $64$luvio_engine_ResourceIngest;
export declare function getTypeCacheKeys(rootKeySet: $64$luvio_engine_DurableStoreKeyMetadataMap, luvio: $64$luvio_engine_Luvio, input: PhotoRecordAvatarRepresentation, fullPathFactory: () => string | $64$luvio_engine_NormalizedKeyMetadata): void;
/**
 * Represents an avatar associated to a Record
 *
 * Keys:
 *    recordId (string): recordId
 */
export interface PhotoRecordAvatarRepresentationNormalized extends AbstractRecordAvatarRepresentation_AbstractRecordAvatarRepresentation {
    /** Retrieve the background color for the photo, if known, otherwise this will be null. */
    backgroundColor: string | null;
    /** ETag like field, readOnly, handy while caching. */
    eTag: string;
    /** Retrieve the height of the photo in pixels, if known, otherwise this will be null. */
    height: number | null;
    /** The photo metadata for the image */
    photoMetadata: PhotoMetadataRepresentation_PhotoMetadataRepresentation;
    /** Retrieve the URL location of the photo. */
    photoUrl: string;
    /** The provider of the image */
    provider: string | null;
    /** Retrieve the width of the photo in pixels, if known, otherwise this will be null. */
    width: number | null;
}
/**
 * Represents an avatar associated to a Record
 *
 * Keys:
 *    recordId (string): recordId
 */
export interface PhotoRecordAvatarRepresentation extends AbstractRecordAvatarRepresentation_AbstractRecordAvatarRepresentation {
    backgroundColor: string | null;
    eTag: string;
    height: number | null;
    photoMetadata: PhotoMetadataRepresentation_PhotoMetadataRepresentation;
    photoUrl: string;
    provider: string | null;
    width: number | null;
    type: 'Photo';
}
