import { IngestPath as $64$luvio_engine_IngestPath, Luvio as $64$luvio_engine_Luvio, Store as $64$luvio_engine_Store, ResourceIngest as $64$luvio_engine_ResourceIngest, FragmentSelection as $64$luvio_engine_FragmentSelection, PathSelection as $64$luvio_engine_PathSelection, StoreLink as $64$luvio_engine_StoreLink, DurableStoreKeyMetadataMap as $64$luvio_engine_DurableStoreKeyMetadataMap, NormalizedKeyMetadata as $64$luvio_engine_NormalizedKeyMetadata } from '@luvio/engine';
import { PicklistValuesRepresentation as PicklistValuesRepresentation_PicklistValuesRepresentation } from './PicklistValuesRepresentation';
export declare const TTL = 900000;
export declare const VERSION = "ec03b0f6da287c949d1ccaa904ddbfd3";
export declare function validate(obj: any, path?: string): TypeError | null;
export declare const RepresentationType: string;
export declare function normalize(input: PicklistValuesCollectionRepresentation, existing: PicklistValuesCollectionRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number): PicklistValuesCollectionRepresentationNormalized;
export interface DynamicIngestParams {
    picklistFieldValues: $64$luvio_engine_ResourceIngest;
}
export declare function dynamicNormalize(ingestParams: DynamicIngestParams): (input: PicklistValuesCollectionRepresentation, existing: PicklistValuesCollectionRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number) => PicklistValuesCollectionRepresentationNormalized;
export declare const select: () => $64$luvio_engine_FragmentSelection;
export interface DynamicSelectParams {
    picklistFieldValues?: $64$luvio_engine_PathSelection;
}
export declare const dynamicSelect: (params: DynamicSelectParams) => $64$luvio_engine_FragmentSelection;
export declare function equals(existing: PicklistValuesCollectionRepresentationNormalized, incoming: PicklistValuesCollectionRepresentationNormalized): boolean;
export declare const ingest: $64$luvio_engine_ResourceIngest;
export declare function getTypeCacheKeys(rootKeySet: $64$luvio_engine_DurableStoreKeyMetadataMap, luvio: $64$luvio_engine_Luvio, input: PicklistValuesCollectionRepresentation, fullPathFactory: () => string | $64$luvio_engine_NormalizedKeyMetadata): void;
export declare function dynamicIngest(ingestParams: DynamicIngestParams): $64$luvio_engine_ResourceIngest;
/**
 * Picklist values for multiple picklist fields and scoped to a record type.
 *
 * Keys:
 *    (none)
 */
export interface PicklistValuesCollectionRepresentationNormalized {
    /** ETag like field, readOnly, handy while caching. */
    eTag: string;
    /** This contains a map of fieldName to PicklistValuesRepresentation for all picklist fields. There would be no entry for non picklistFields in this map */
    picklistFieldValues: {
        [key: string]: $64$luvio_engine_StoreLink;
    };
}
/**
 * Picklist values for multiple picklist fields and scoped to a record type.
 *
 * Keys:
 *    (none)
 */
export interface PicklistValuesCollectionRepresentation {
    eTag: string;
    picklistFieldValues: {
        [key: string]: PicklistValuesRepresentation_PicklistValuesRepresentation;
    };
}
