import { KeyMetadata as $64$luvio_engine_KeyMetadata, NormalizedKeyMetadata as $64$luvio_engine_NormalizedKeyMetadata, Luvio as $64$luvio_engine_Luvio, IngestPath as $64$luvio_engine_IngestPath, Store as $64$luvio_engine_Store, FragmentSelection as $64$luvio_engine_FragmentSelection, ResourceIngest as $64$luvio_engine_ResourceIngest, DurableStoreKeyMetadataMap as $64$luvio_engine_DurableStoreKeyMetadataMap } from '@luvio/engine';
export declare const VERSION = "7e00c51105cbf56a79ab8fcddf462c1e";
export declare function validate(obj: any, path?: string): TypeError | null;
export declare const RepresentationType: string;
export interface KeyParams extends $64$luvio_engine_KeyMetadata {
    id: string;
}
export type QuickActionExecutionRepresentationNormalizedKeyMetadata = KeyParams & $64$luvio_engine_NormalizedKeyMetadata;
export type PartialQuickActionExecutionRepresentationNormalizedKeyMetadata = Partial<KeyParams> & $64$luvio_engine_NormalizedKeyMetadata;
export declare function keyBuilder(luvio: $64$luvio_engine_Luvio, config: KeyParams): string;
export declare function keyBuilder_StructuredKey(luvio: $64$luvio_engine_Luvio, config: KeyParams): QuickActionExecutionRepresentationNormalizedKeyMetadata;
export declare function keyBuilderFromType(luvio: $64$luvio_engine_Luvio, object: QuickActionExecutionRepresentation): string;
export declare function keyBuilderFromType_StructuredKey(luvio: $64$luvio_engine_Luvio, object: QuickActionExecutionRepresentation): $64$luvio_engine_NormalizedKeyMetadata;
export declare function normalize(input: QuickActionExecutionRepresentation, existing: QuickActionExecutionRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number): QuickActionExecutionRepresentationNormalized;
export declare const select: () => $64$luvio_engine_FragmentSelection;
export declare function equals(existing: QuickActionExecutionRepresentationNormalized, incoming: QuickActionExecutionRepresentationNormalized): boolean;
export declare const ingest: $64$luvio_engine_ResourceIngest;
export declare function getTypeCacheKeys(rootKeySet: $64$luvio_engine_DurableStoreKeyMetadataMap, luvio: $64$luvio_engine_Luvio, input: QuickActionExecutionRepresentation, fullPathFactory: () => string | $64$luvio_engine_NormalizedKeyMetadata): void;
/**
 * Perform quick action response presentation.
 *
 * Keys:
 *    id (string): id
 */
export interface QuickActionExecutionRepresentationNormalized {
    /** The context ID */
    contextId: string | null;
    /** ETag like field, readOnly, handy while caching. */
    eTag: string;
    /** The ID of created feed item as string. */
    feedItemId: string | null;
    /** The ID of created or updated record as string. */
    id: string;
    /** Indicates if new records are created with the operation. */
    isCreated: boolean;
    /** Indicates if the operation is successful. */
    isSuccess: boolean;
    /** The success message of the operation. */
    successMessage: string;
}
/**
 * Perform quick action response presentation.
 *
 * Keys:
 *    id (string): id
 */
export interface QuickActionExecutionRepresentation {
    contextId: string | null;
    eTag: string;
    feedItemId: string | null;
    id: string;
    isCreated: boolean;
    isSuccess: boolean;
    successMessage: string;
}
