import { RecordLayoutRepresentation as RecordLayoutRepresentation_RecordLayoutRepresentation } from './RecordLayoutRepresentation';
import { KeyMetadata as $64$luvio_engine_KeyMetadata, NormalizedKeyMetadata as $64$luvio_engine_NormalizedKeyMetadata, Luvio as $64$luvio_engine_Luvio, IngestPath as $64$luvio_engine_IngestPath, Store as $64$luvio_engine_Store, BaseFragment as $64$luvio_engine_BaseFragment, ResourceIngest as $64$luvio_engine_ResourceIngest, StoreLink as $64$luvio_engine_StoreLink, DurableStoreKeyMetadataMap as $64$luvio_engine_DurableStoreKeyMetadataMap } from '@luvio/engine';
export declare const TTL = 900000;
export declare const VERSION = "35f3eec8ce7f6001c6d5d17821b75bb9";
export declare function validate(obj: any, path?: string): TypeError | null;
export declare const RepresentationType: string;
export interface KeyParams extends $64$luvio_engine_KeyMetadata {
    actionApiName: string;
}
export type QuickActionLayoutRepresentationNormalizedKeyMetadata = KeyParams & $64$luvio_engine_NormalizedKeyMetadata;
export type PartialQuickActionLayoutRepresentationNormalizedKeyMetadata = Partial<KeyParams> & $64$luvio_engine_NormalizedKeyMetadata;
export declare function keyBuilder(luvio: $64$luvio_engine_Luvio, config: KeyParams): string;
export declare function keyBuilder_StructuredKey(luvio: $64$luvio_engine_Luvio, config: KeyParams): QuickActionLayoutRepresentationNormalizedKeyMetadata;
export declare function keyBuilderFromType(luvio: $64$luvio_engine_Luvio, object: QuickActionLayoutRepresentation): string;
export declare function keyBuilderFromType_StructuredKey(luvio: $64$luvio_engine_Luvio, object: QuickActionLayoutRepresentation): $64$luvio_engine_NormalizedKeyMetadata;
export declare function normalize(input: QuickActionLayoutRepresentation, existing: QuickActionLayoutRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number): QuickActionLayoutRepresentationNormalized;
export declare const select: () => $64$luvio_engine_BaseFragment;
export declare function equals(existing: QuickActionLayoutRepresentationNormalized, incoming: QuickActionLayoutRepresentationNormalized): boolean;
export declare const ingest: $64$luvio_engine_ResourceIngest;
export declare function getTypeCacheKeys(rootKeySet: $64$luvio_engine_DurableStoreKeyMetadataMap, luvio: $64$luvio_engine_Luvio, input: QuickActionLayoutRepresentation, fullPathFactory: () => string | $64$luvio_engine_NormalizedKeyMetadata): void;
/**
 * Quick action layout representation for a specific action api name
 *
 * Keys:
 *    actionApiName (string): actionApiName
 */
export interface QuickActionLayoutRepresentationNormalized {
    /** quick action name */
    actionApiName: string;
    /** ETag like field, readOnly, handy while caching. */
    eTag: string;
    layout: $64$luvio_engine_StoreLink;
}
/**
 * Quick action layout representation for a specific action api name
 *
 * Keys:
 *    actionApiName (string): actionApiName
 */
export interface QuickActionLayoutRepresentation {
    actionApiName: string;
    eTag: string;
    layout: RecordLayoutRepresentation_RecordLayoutRepresentation;
}
