import { IngestPath as $64$luvio_engine_IngestPath, Luvio as $64$luvio_engine_Luvio, Store as $64$luvio_engine_Store, ResourceIngest as $64$luvio_engine_ResourceIngest, FragmentSelection as $64$luvio_engine_FragmentSelection, LinkSelection as $64$luvio_engine_LinkSelection, PathSelection as $64$luvio_engine_PathSelection, StoreLink as $64$luvio_engine_StoreLink, DurableStoreKeyMetadataMap as $64$luvio_engine_DurableStoreKeyMetadataMap, NormalizedKeyMetadata as $64$luvio_engine_NormalizedKeyMetadata } from '@luvio/engine';
import { RecordLayoutRepresentation as RecordLayoutRepresentation_RecordLayoutRepresentation } from './RecordLayoutRepresentation';
import { ObjectInfoRepresentation as ObjectInfoRepresentation_ObjectInfoRepresentation } from './ObjectInfoRepresentation';
import { RecordCreateDefaultRecordRepresentation as RecordCreateDefaultRecordRepresentation_RecordCreateDefaultRecordRepresentation } from './RecordCreateDefaultRecordRepresentation';
export declare const TTL = 900000;
export declare const VERSION = "894a62b8f5de5535f2483fb2c3abca8e";
export declare function validate(obj: any, path?: string): TypeError | null;
export declare const RepresentationType: string;
export declare function normalize(input: RecordDefaultsRepresentation, existing: RecordDefaultsRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number): RecordDefaultsRepresentationNormalized;
export interface DynamicIngestParams {
    layout: $64$luvio_engine_ResourceIngest;
    objectInfos: $64$luvio_engine_ResourceIngest;
    record: $64$luvio_engine_ResourceIngest;
}
export declare function dynamicNormalize(ingestParams: DynamicIngestParams): (input: RecordDefaultsRepresentation, existing: RecordDefaultsRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number) => RecordDefaultsRepresentationNormalized;
export declare const select: () => $64$luvio_engine_FragmentSelection;
export interface DynamicSelectParams {
    layout?: $64$luvio_engine_LinkSelection;
    objectInfos?: $64$luvio_engine_PathSelection;
    record?: $64$luvio_engine_LinkSelection;
}
export declare const dynamicSelect: (params: DynamicSelectParams) => $64$luvio_engine_FragmentSelection;
export declare function equals(existing: RecordDefaultsRepresentationNormalized, incoming: RecordDefaultsRepresentationNormalized): boolean;
export declare const ingest: $64$luvio_engine_ResourceIngest;
export declare function getTypeCacheKeys(rootKeySet: $64$luvio_engine_DurableStoreKeyMetadataMap, luvio: $64$luvio_engine_Luvio, input: RecordDefaultsRepresentation, fullPathFactory: () => string | $64$luvio_engine_NormalizedKeyMetadata): void;
export declare function dynamicIngest(ingestParams: DynamicIngestParams): $64$luvio_engine_ResourceIngest;
/**
 * Record defaults.
 *
 * Keys:
 *    (none)
 */
export interface RecordDefaultsRepresentationNormalized {
    /** Record layout. */
    layout: $64$luvio_engine_StoreLink | null;
    /** Object metadata. */
    objectInfos: {
        [key: string]: $64$luvio_engine_StoreLink;
    };
    record: $64$luvio_engine_StoreLink;
}
/**
 * Record defaults.
 *
 * Keys:
 *    (none)
 */
export interface RecordDefaultsRepresentation {
    layout: RecordLayoutRepresentation_RecordLayoutRepresentation | null;
    objectInfos: {
        [key: string]: ObjectInfoRepresentation_ObjectInfoRepresentation;
    };
    record: RecordCreateDefaultRecordRepresentation_RecordCreateDefaultRecordRepresentation;
}
