import { KeyMetadata as $64$luvio_engine_KeyMetadata, NormalizedKeyMetadata as $64$luvio_engine_NormalizedKeyMetadata, Luvio as $64$luvio_engine_Luvio, IngestPath as $64$luvio_engine_IngestPath, Store as $64$luvio_engine_Store, ResourceIngest as $64$luvio_engine_ResourceIngest, FragmentSelection as $64$luvio_engine_FragmentSelection, PathSelection as $64$luvio_engine_PathSelection, LinkSelection as $64$luvio_engine_LinkSelection, StoreLink as $64$luvio_engine_StoreLink, DurableStoreKeyMetadataMap as $64$luvio_engine_DurableStoreKeyMetadataMap } from '@luvio/engine';
import { ObjectInfoRepresentation as ObjectInfoRepresentation_ObjectInfoRepresentation } from './ObjectInfoRepresentation';
import { RecordTemplateCreateRepresentation as RecordTemplateCreateRepresentation_RecordTemplateCreateRepresentation } from './RecordTemplateCreateRepresentation';
export declare const TTL = 900000;
export declare const VERSION = "30493e7ac0677e35242026bb959c079e";
export declare function validate(obj: any, path?: string): TypeError | null;
export declare const RepresentationType: string;
export interface KeyParams extends $64$luvio_engine_KeyMetadata {
    objectApiName: string;
    recordTypeId: string | null;
}
export type RecordDefaultsTemplateCreateRepresentationNormalizedKeyMetadata = KeyParams & $64$luvio_engine_NormalizedKeyMetadata;
export type PartialRecordDefaultsTemplateCreateRepresentationNormalizedKeyMetadata = Partial<KeyParams> & $64$luvio_engine_NormalizedKeyMetadata;
export declare function keyBuilder(luvio: $64$luvio_engine_Luvio, config: KeyParams): string;
export declare function keyBuilder_StructuredKey(luvio: $64$luvio_engine_Luvio, config: KeyParams): RecordDefaultsTemplateCreateRepresentationNormalizedKeyMetadata;
export declare function keyBuilderFromType(luvio: $64$luvio_engine_Luvio, object: RecordDefaultsTemplateCreateRepresentation): string;
export declare function keyBuilderFromType_StructuredKey(luvio: $64$luvio_engine_Luvio, object: RecordDefaultsTemplateCreateRepresentation): $64$luvio_engine_NormalizedKeyMetadata;
export declare function normalize(input: RecordDefaultsTemplateCreateRepresentation, existing: RecordDefaultsTemplateCreateRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number): RecordDefaultsTemplateCreateRepresentationNormalized;
export interface DynamicIngestParams {
    objectInfos: $64$luvio_engine_ResourceIngest;
    record: $64$luvio_engine_ResourceIngest;
}
export declare function dynamicNormalize(ingestParams: DynamicIngestParams): (input: RecordDefaultsTemplateCreateRepresentation, existing: RecordDefaultsTemplateCreateRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number) => RecordDefaultsTemplateCreateRepresentationNormalized;
export declare const select: () => $64$luvio_engine_FragmentSelection;
export interface DynamicSelectParams {
    objectInfos?: $64$luvio_engine_PathSelection;
    record?: $64$luvio_engine_LinkSelection;
}
export declare const dynamicSelect: (params: DynamicSelectParams) => $64$luvio_engine_FragmentSelection;
export declare function equals(existing: RecordDefaultsTemplateCreateRepresentationNormalized, incoming: RecordDefaultsTemplateCreateRepresentationNormalized): boolean;
export declare const ingest: $64$luvio_engine_ResourceIngest;
export declare function getTypeCacheKeys(rootKeySet: $64$luvio_engine_DurableStoreKeyMetadataMap, luvio: $64$luvio_engine_Luvio, input: RecordDefaultsTemplateCreateRepresentation, fullPathFactory: () => string | $64$luvio_engine_NormalizedKeyMetadata): void;
export declare function dynamicIngest(ingestParams: DynamicIngestParams): $64$luvio_engine_ResourceIngest;
/**
 * Record defaults template for specifying record create information and object information
 *
 * Keys:
 *    objectApiName (string): record.apiName
 *    recordTypeId (string | null): record.recordTypeId
 */
export interface RecordDefaultsTemplateCreateRepresentationNormalized {
    /** Object metadata. */
    objectInfos: {
        [key: string]: $64$luvio_engine_StoreLink;
    };
    record: $64$luvio_engine_StoreLink;
}
/**
 * Record defaults template for specifying record create information and object information
 *
 * Keys:
 *    objectApiName (string): record.apiName
 *    recordTypeId (string | null): record.recordTypeId
 */
export interface RecordDefaultsTemplateCreateRepresentation {
    objectInfos: {
        [key: string]: ObjectInfoRepresentation_ObjectInfoRepresentation;
    };
    record: RecordTemplateCreateRepresentation_RecordTemplateCreateRepresentation;
}
