import { RecordLayoutSaveOptionRepresentation as RecordLayoutSaveOptionRepresentation_RecordLayoutSaveOptionRepresentation } from './RecordLayoutSaveOptionRepresentation';
import { RecordLayoutSectionRepresentation as RecordLayoutSectionRepresentation_RecordLayoutSectionRepresentation } from './RecordLayoutSectionRepresentation';
import { KeyMetadata as $64$luvio_engine_KeyMetadata, NormalizedKeyMetadata as $64$luvio_engine_NormalizedKeyMetadata, Luvio as $64$luvio_engine_Luvio, IngestPath as $64$luvio_engine_IngestPath, Store as $64$luvio_engine_Store, BaseFragment as $64$luvio_engine_BaseFragment, ResourceIngest as $64$luvio_engine_ResourceIngest, DurableStoreKeyMetadataMap as $64$luvio_engine_DurableStoreKeyMetadataMap } from '@luvio/engine';
export declare const TTL = 900000;
export declare const VERSION = "fb515e25a89ca1ec154dc865e72b913a";
export declare function validate(obj: any, path?: string): TypeError | null;
export declare const RepresentationType: string;
export interface KeyParams extends $64$luvio_engine_KeyMetadata {
    recordTypeId: string | null;
    objectApiName: string | null;
    layoutType: string;
    mode: string;
}
export type RecordLayoutRepresentationNormalizedKeyMetadata = KeyParams & $64$luvio_engine_NormalizedKeyMetadata;
export type PartialRecordLayoutRepresentationNormalizedKeyMetadata = Partial<KeyParams> & $64$luvio_engine_NormalizedKeyMetadata;
export declare function keyBuilder(luvio: $64$luvio_engine_Luvio, config: KeyParams): string;
export declare function keyBuilder_StructuredKey(luvio: $64$luvio_engine_Luvio, config: KeyParams): RecordLayoutRepresentationNormalizedKeyMetadata;
export declare function keyBuilderFromType(luvio: $64$luvio_engine_Luvio, object: RecordLayoutRepresentation): string;
export declare function keyBuilderFromType_StructuredKey(luvio: $64$luvio_engine_Luvio, object: RecordLayoutRepresentation): $64$luvio_engine_NormalizedKeyMetadata;
export declare function normalize(input: RecordLayoutRepresentation, existing: RecordLayoutRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number): RecordLayoutRepresentationNormalized;
export declare const select: () => $64$luvio_engine_BaseFragment;
export declare function equals(existing: RecordLayoutRepresentationNormalized, incoming: RecordLayoutRepresentationNormalized): boolean;
export declare const ingest: $64$luvio_engine_ResourceIngest;
export declare function getTypeCacheKeys(rootKeySet: $64$luvio_engine_DurableStoreKeyMetadataMap, luvio: $64$luvio_engine_Luvio, input: RecordLayoutRepresentation, fullPathFactory: () => string | $64$luvio_engine_NormalizedKeyMetadata): void;
/**
 * Record layout.
 *
 * Keys:
 *    recordTypeId (string | null): recordTypeId
 *    objectApiName (string | null): objectApiName
 *    layoutType (string): layoutType
 *    mode (string): mode
 */
export interface RecordLayoutRepresentationNormalized {
    /** ETag like field, readOnly, handy while caching. */
    eTag: string;
    /** Layout ID. */
    id: string | null;
    /** Layout type. */
    layoutType: string;
    /** Mode. */
    mode: string;
    /** Object API name. */
    objectApiName: string | null;
    /** Record type ID. */
    recordTypeId: string | null;
    /** Layout save options. */
    saveOptions: Array<RecordLayoutSaveOptionRepresentation_RecordLayoutSaveOptionRepresentation>;
    /** Layout sections. */
    sections: Array<RecordLayoutSectionRepresentation_RecordLayoutSectionRepresentation>;
}
/**
 * Record layout.
 *
 * Keys:
 *    recordTypeId (string | null): recordTypeId
 *    objectApiName (string | null): objectApiName
 *    layoutType (string): layoutType
 *    mode (string): mode
 */
export interface RecordLayoutRepresentation {
    eTag: string;
    id: string | null;
    layoutType: string;
    mode: string;
    objectApiName: string | null;
    recordTypeId: string | null;
    saveOptions: Array<RecordLayoutSaveOptionRepresentation_RecordLayoutSaveOptionRepresentation>;
    sections: Array<RecordLayoutSectionRepresentation_RecordLayoutSectionRepresentation>;
}
