import { RecordLayoutRowRepresentation as RecordLayoutRowRepresentation_RecordLayoutRowRepresentation } from './RecordLayoutRowRepresentation';
import { IngestPath as $64$luvio_engine_IngestPath, Luvio as $64$luvio_engine_Luvio, Store as $64$luvio_engine_Store, FragmentSelection as $64$luvio_engine_FragmentSelection, ResourceIngest as $64$luvio_engine_ResourceIngest, DurableStoreKeyMetadataMap as $64$luvio_engine_DurableStoreKeyMetadataMap, NormalizedKeyMetadata as $64$luvio_engine_NormalizedKeyMetadata } from '@luvio/engine';
export declare const VERSION = "fc85a73f7d314598764e758e2a131609";
export declare function validate(obj: any, path?: string): TypeError | null;
export declare const RepresentationType: string;
export declare function normalize(input: RecordLayoutSectionRepresentation, existing: RecordLayoutSectionRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number): RecordLayoutSectionRepresentationNormalized;
export declare const select: () => $64$luvio_engine_FragmentSelection;
export declare function equals(existing: RecordLayoutSectionRepresentationNormalized, incoming: RecordLayoutSectionRepresentationNormalized): boolean;
export declare const ingest: $64$luvio_engine_ResourceIngest;
export declare function getTypeCacheKeys(rootKeySet: $64$luvio_engine_DurableStoreKeyMetadataMap, luvio: $64$luvio_engine_Luvio, input: RecordLayoutSectionRepresentation, fullPathFactory: () => string | $64$luvio_engine_NormalizedKeyMetadata): void;
/**
 * Record layout section.
 *
 * Keys:
 *    (none)
 */
export interface RecordLayoutSectionRepresentationNormalized {
    /** Indicates whether the section may be collapsed. */
    collapsible: boolean;
    /** Number of columns in the section. */
    columns: number;
    /** Heading text for the section. */
    heading: string | null;
    /** Section ID. */
    id: string | null;
    /** The rows in the section. */
    layoutRows: Array<RecordLayoutRowRepresentation_RecordLayoutRowRepresentation>;
    /** Number of rows in the section. */
    rows: number;
    /** Indicates whether the heading text is expected to be displayed. */
    useHeading: boolean;
}
/**
 * Record layout section.
 *
 * Keys:
 *    (none)
 */
export interface RecordLayoutSectionRepresentation {
    collapsible: boolean;
    columns: number;
    heading: string | null;
    id: string | null;
    layoutRows: Array<RecordLayoutRowRepresentation_RecordLayoutRowRepresentation>;
    rows: number;
    useHeading: boolean;
}
