import { RecordTypeInfoRepresentation as RecordTypeInfoRepresentation_RecordTypeInfoRepresentation } from './RecordTypeInfoRepresentation';
import { KeyMetadata as $64$luvio_engine_KeyMetadata, NormalizedKeyMetadata as $64$luvio_engine_NormalizedKeyMetadata, Luvio as $64$luvio_engine_Luvio, IngestPath as $64$luvio_engine_IngestPath, Store as $64$luvio_engine_Store, ResourceIngest as $64$luvio_engine_ResourceIngest, FragmentSelection as $64$luvio_engine_FragmentSelection, PathSelection as $64$luvio_engine_PathSelection, StoreLink as $64$luvio_engine_StoreLink, DurableStoreKeyMetadataMap as $64$luvio_engine_DurableStoreKeyMetadataMap } from '@luvio/engine';
import { RecordCollectionRepresentation as RecordCollectionRepresentation_RecordCollectionRepresentation } from './RecordCollectionRepresentation';
import { FieldValueRepresentation as FieldValueRepresentation_FieldValueRepresentation } from './FieldValueRepresentation';
export declare const TTL = 30000;
export declare const VERSION = "98c5b18512e48ca8d28727549507e4ba";
export declare function validate(obj: any, path?: string): TypeError | null;
export declare const RepresentationType: string;
export interface KeyParams extends $64$luvio_engine_KeyMetadata {
    recordId: string;
}
export type RecordRepresentationNormalizedKeyMetadata = KeyParams & $64$luvio_engine_NormalizedKeyMetadata;
export type PartialRecordRepresentationNormalizedKeyMetadata = Partial<KeyParams> & $64$luvio_engine_NormalizedKeyMetadata;
export declare function keyBuilder(luvio: $64$luvio_engine_Luvio, config: KeyParams): string;
export declare function keyBuilder_StructuredKey(luvio: $64$luvio_engine_Luvio, config: KeyParams): RecordRepresentationNormalizedKeyMetadata;
export declare function keyBuilderFromType(luvio: $64$luvio_engine_Luvio, object: RecordRepresentation): string;
export declare function keyBuilderFromType_StructuredKey(luvio: $64$luvio_engine_Luvio, object: RecordRepresentation): $64$luvio_engine_NormalizedKeyMetadata;
export declare function normalize(input: RecordRepresentation, existing: RecordRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number): RecordRepresentationNormalized;
export interface DynamicIngestParams {
    childRelationships: $64$luvio_engine_ResourceIngest;
    fields: $64$luvio_engine_ResourceIngest;
}
export declare function dynamicNormalize(ingestParams: DynamicIngestParams): (input: RecordRepresentation, existing: RecordRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number) => RecordRepresentationNormalized;
export declare const select: () => $64$luvio_engine_FragmentSelection;
export interface DynamicSelectParams {
    childRelationships?: $64$luvio_engine_PathSelection;
    fields?: $64$luvio_engine_PathSelection;
}
export declare const dynamicSelect: (params: DynamicSelectParams) => $64$luvio_engine_FragmentSelection;
export declare function equals(existing: RecordRepresentationNormalized, incoming: RecordRepresentationNormalized): boolean;
export declare const ingest: $64$luvio_engine_ResourceIngest;
export declare function getTypeCacheKeys(rootKeySet: $64$luvio_engine_DurableStoreKeyMetadataMap, luvio: $64$luvio_engine_Luvio, input: RecordRepresentation, fullPathFactory: () => string | $64$luvio_engine_NormalizedKeyMetadata): void;
export declare function dynamicIngest(ingestParams: DynamicIngestParams): $64$luvio_engine_ResourceIngest;
/**
 * Record.
 *
 * Keys:
 *    recordId (string): id
 */
export interface RecordRepresentationNormalized {
    /** The record's object API name. */
    apiName: string;
    /** The child relationship data for this record */
    childRelationships: {
        [key: string]: $64$luvio_engine_StoreLink;
    };
    /** ETag like field, readOnly, handy while caching. */
    eTag: string;
    /** The field data for this record, matching the requested layout and mode. */
    fields: {
        [key: string]: $64$luvio_engine_StoreLink;
    };
    /** The ID of this record. */
    id: string;
    /** The lastModifiedById of the record. */
    lastModifiedById: string | null;
    /** The lastModifiedDate of the record. */
    lastModifiedDate: string | null;
    /** The RecordTypeId of the record. */
    recordTypeId: string | null;
    /** The record type info for this record, if any. */
    recordTypeInfo: RecordTypeInfoRepresentation_RecordTypeInfoRepresentation | null;
    /** The systemModstamp of the record. */
    systemModstamp: string | null;
    /** Record Version like field, readOnly, handy while caching and comparing versions of records. */
    weakEtag: number;
}
/**
 * Record.
 *
 * Keys:
 *    recordId (string): id
 */
export interface RecordRepresentation {
    apiName: string;
    childRelationships: {
        [key: string]: RecordCollectionRepresentation_RecordCollectionRepresentation;
    };
    eTag: string;
    fields: {
        [key: string]: FieldValueRepresentation_FieldValueRepresentation;
    };
    id: string;
    lastModifiedById: string | null;
    lastModifiedDate: string | null;
    recordTypeId: string | null;
    recordTypeInfo: RecordTypeInfoRepresentation_RecordTypeInfoRepresentation | null;
    systemModstamp: string | null;
    weakEtag: number;
}
export declare const notifyUpdateAvailableFactory: (luvio: $64$luvio_engine_Luvio) => (configs: Partial<KeyParams>[]) => Promise<void>;
