import { KeyMetadata as $64$luvio_engine_KeyMetadata, NormalizedKeyMetadata as $64$luvio_engine_NormalizedKeyMetadata, Luvio as $64$luvio_engine_Luvio, IngestPath as $64$luvio_engine_IngestPath, Store as $64$luvio_engine_Store, ResourceIngest as $64$luvio_engine_ResourceIngest, FragmentSelection as $64$luvio_engine_FragmentSelection, PathSelection as $64$luvio_engine_PathSelection, StoreLink as $64$luvio_engine_StoreLink, DurableStoreKeyMetadataMap as $64$luvio_engine_DurableStoreKeyMetadataMap } from '@luvio/engine';
import { FieldValueRepresentation as FieldValueRepresentation_FieldValueRepresentation } from './FieldValueRepresentation';
export declare const TTL = 1000;
export declare const VERSION = "6a63c9ca6dda2e125d94e004f83240d8";
export declare function validate(obj: any, path?: string): TypeError | null;
export declare const RepresentationType: string;
export interface KeyParams extends $64$luvio_engine_KeyMetadata {
    cloneSourceId: string;
    recordTypeId: string | null;
}
export type RecordTemplateCloneRepresentationNormalizedKeyMetadata = KeyParams & $64$luvio_engine_NormalizedKeyMetadata;
export type PartialRecordTemplateCloneRepresentationNormalizedKeyMetadata = Partial<KeyParams> & $64$luvio_engine_NormalizedKeyMetadata;
export declare function keyBuilder(luvio: $64$luvio_engine_Luvio, config: KeyParams): string;
export declare function keyBuilder_StructuredKey(luvio: $64$luvio_engine_Luvio, config: KeyParams): RecordTemplateCloneRepresentationNormalizedKeyMetadata;
export declare function keyBuilderFromType(luvio: $64$luvio_engine_Luvio, object: RecordTemplateCloneRepresentation): string;
export declare function keyBuilderFromType_StructuredKey(luvio: $64$luvio_engine_Luvio, object: RecordTemplateCloneRepresentation): $64$luvio_engine_NormalizedKeyMetadata;
export declare function normalize(input: RecordTemplateCloneRepresentation, existing: RecordTemplateCloneRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number): RecordTemplateCloneRepresentationNormalized;
export interface DynamicIngestParams {
    fields: $64$luvio_engine_ResourceIngest;
}
export declare function dynamicNormalize(ingestParams: DynamicIngestParams): (input: RecordTemplateCloneRepresentation, existing: RecordTemplateCloneRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number) => RecordTemplateCloneRepresentationNormalized;
export declare const select: () => $64$luvio_engine_FragmentSelection;
export interface DynamicSelectParams {
    fields?: $64$luvio_engine_PathSelection;
}
export declare const dynamicSelect: (params: DynamicSelectParams) => $64$luvio_engine_FragmentSelection;
export declare function equals(existing: RecordTemplateCloneRepresentationNormalized, incoming: RecordTemplateCloneRepresentationNormalized): boolean;
export declare const ingest: $64$luvio_engine_ResourceIngest;
export declare function getTypeCacheKeys(rootKeySet: $64$luvio_engine_DurableStoreKeyMetadataMap, luvio: $64$luvio_engine_Luvio, input: RecordTemplateCloneRepresentation, fullPathFactory: () => string | $64$luvio_engine_NormalizedKeyMetadata): void;
export declare function dynamicIngest(ingestParams: DynamicIngestParams): $64$luvio_engine_ResourceIngest;
/**
 * Record template for specifying api name, fields, record typeinfo and recordtypeid information
 *
 * Keys:
 *    cloneSourceId (string): cloneSourceId
 *    recordTypeId (string | null): recordTypeId
 */
export interface RecordTemplateCloneRepresentationNormalized {
    /** The record's object API name. */
    apiName: string;
    /** The cloneSourceId of the record. */
    cloneSourceId: string;
    /** The field data for this record, matching the requested layout and mode. */
    fields: {
        [key: string]: $64$luvio_engine_StoreLink;
    };
    /** The RecordTypeId of the record. */
    recordTypeId: string | null;
}
/**
 * Record template for specifying api name, fields, record typeinfo and recordtypeid information
 *
 * Keys:
 *    cloneSourceId (string): cloneSourceId
 *    recordTypeId (string | null): recordTypeId
 */
export interface RecordTemplateCloneRepresentation {
    apiName: string;
    cloneSourceId: string;
    fields: {
        [key: string]: FieldValueRepresentation_FieldValueRepresentation;
    };
    recordTypeId: string | null;
}
