import { KeyMetadata as $64$luvio_engine_KeyMetadata, NormalizedKeyMetadata as $64$luvio_engine_NormalizedKeyMetadata, Luvio as $64$luvio_engine_Luvio, IngestPath as $64$luvio_engine_IngestPath, Store as $64$luvio_engine_Store, ResourceIngest as $64$luvio_engine_ResourceIngest, FragmentSelection as $64$luvio_engine_FragmentSelection, PathSelection as $64$luvio_engine_PathSelection, StoreLink as $64$luvio_engine_StoreLink, DurableStoreKeyMetadataMap as $64$luvio_engine_DurableStoreKeyMetadataMap } from '@luvio/engine';
import { FieldValueRepresentation as FieldValueRepresentation_FieldValueRepresentation } from './FieldValueRepresentation';
export declare const TTL = 30000;
export declare const VERSION = "665de0fdde39efd6f1098e374117ef58";
export declare function validate(obj: any, path?: string): TypeError | null;
export declare const RepresentationType: string;
export interface KeyParams extends $64$luvio_engine_KeyMetadata {
    apiName: string;
    recordTypeId: string | null;
}
export type RecordTemplateCreateRepresentationNormalizedKeyMetadata = KeyParams & $64$luvio_engine_NormalizedKeyMetadata;
export type PartialRecordTemplateCreateRepresentationNormalizedKeyMetadata = Partial<KeyParams> & $64$luvio_engine_NormalizedKeyMetadata;
export declare function keyBuilder(luvio: $64$luvio_engine_Luvio, config: KeyParams): string;
export declare function keyBuilder_StructuredKey(luvio: $64$luvio_engine_Luvio, config: KeyParams): RecordTemplateCreateRepresentationNormalizedKeyMetadata;
export declare function keyBuilderFromType(luvio: $64$luvio_engine_Luvio, object: RecordTemplateCreateRepresentation): string;
export declare function keyBuilderFromType_StructuredKey(luvio: $64$luvio_engine_Luvio, object: RecordTemplateCreateRepresentation): $64$luvio_engine_NormalizedKeyMetadata;
export declare function normalize(input: RecordTemplateCreateRepresentation, existing: RecordTemplateCreateRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number): RecordTemplateCreateRepresentationNormalized;
export interface DynamicIngestParams {
    fields: $64$luvio_engine_ResourceIngest;
}
export declare function dynamicNormalize(ingestParams: DynamicIngestParams): (input: RecordTemplateCreateRepresentation, existing: RecordTemplateCreateRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number) => RecordTemplateCreateRepresentationNormalized;
export declare const select: () => $64$luvio_engine_FragmentSelection;
export interface DynamicSelectParams {
    fields?: $64$luvio_engine_PathSelection;
}
export declare const dynamicSelect: (params: DynamicSelectParams) => $64$luvio_engine_FragmentSelection;
export declare function equals(existing: RecordTemplateCreateRepresentationNormalized, incoming: RecordTemplateCreateRepresentationNormalized): boolean;
export declare const ingest: $64$luvio_engine_ResourceIngest;
export declare function getTypeCacheKeys(rootKeySet: $64$luvio_engine_DurableStoreKeyMetadataMap, luvio: $64$luvio_engine_Luvio, input: RecordTemplateCreateRepresentation, fullPathFactory: () => string | $64$luvio_engine_NormalizedKeyMetadata): void;
export declare function dynamicIngest(ingestParams: DynamicIngestParams): $64$luvio_engine_ResourceIngest;
/**
 * Record defaults create template for specifying api name, fields, record typeinfo and recordtypeid information
 *
 * Keys:
 *    apiName (string): apiName
 *    recordTypeId (string | null): recordTypeId
 */
export interface RecordTemplateCreateRepresentationNormalized {
    /** The record's object API name. */
    apiName: string;
    /** The field data for this record, matching the requested layout and mode. */
    fields: {
        [key: string]: $64$luvio_engine_StoreLink;
    };
    /** The RecordTypeId of the record. */
    recordTypeId: string | null;
}
/**
 * Record defaults create template for specifying api name, fields, record typeinfo and recordtypeid information
 *
 * Keys:
 *    apiName (string): apiName
 *    recordTypeId (string | null): recordTypeId
 */
export interface RecordTemplateCreateRepresentation {
    apiName: string;
    fields: {
        [key: string]: FieldValueRepresentation_FieldValueRepresentation;
    };
    recordTypeId: string | null;
}
