import { IngestPath as $64$luvio_engine_IngestPath, Luvio as $64$luvio_engine_Luvio, Store as $64$luvio_engine_Store, ResourceIngest as $64$luvio_engine_ResourceIngest, FragmentSelection as $64$luvio_engine_FragmentSelection, PathSelection as $64$luvio_engine_PathSelection, StoreLink as $64$luvio_engine_StoreLink, DurableStoreKeyMetadataMap as $64$luvio_engine_DurableStoreKeyMetadataMap, NormalizedKeyMetadata as $64$luvio_engine_NormalizedKeyMetadata } from '@luvio/engine';
import { RecordLayoutUserStateRepresentation as RecordLayoutUserStateRepresentation_RecordLayoutUserStateRepresentation } from './RecordLayoutUserStateRepresentation';
import { RecordLayoutRepresentation as RecordLayoutRepresentation_RecordLayoutRepresentation } from './RecordLayoutRepresentation';
import { ObjectInfoRepresentation as ObjectInfoRepresentation_ObjectInfoRepresentation } from './ObjectInfoRepresentation';
import { RecordRepresentation as RecordRepresentation_RecordRepresentation } from './RecordRepresentation';
export declare const TTL = 900000;
export declare const VERSION = "49cdd4bc235a6094c3559cc7735b3b6d";
export declare function validate(obj: any, path?: string): TypeError | null;
export declare const RepresentationType: string;
export declare function normalize(input: RecordUiRepresentation, existing: RecordUiRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number): RecordUiRepresentationNormalized;
export interface DynamicIngestParams {
    layoutUserStates: $64$luvio_engine_ResourceIngest;
    layouts: $64$luvio_engine_ResourceIngest;
    objectInfos: $64$luvio_engine_ResourceIngest;
    records: $64$luvio_engine_ResourceIngest;
}
export declare function dynamicNormalize(ingestParams: DynamicIngestParams): (input: RecordUiRepresentation, existing: RecordUiRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number) => RecordUiRepresentationNormalized;
export declare const select: () => $64$luvio_engine_FragmentSelection;
export interface DynamicSelectParams {
    layoutUserStates?: $64$luvio_engine_PathSelection;
    layouts?: $64$luvio_engine_PathSelection;
    objectInfos?: $64$luvio_engine_PathSelection;
    records?: $64$luvio_engine_PathSelection;
}
export declare const dynamicSelect: (params: DynamicSelectParams) => $64$luvio_engine_FragmentSelection;
export declare function equals(existing: RecordUiRepresentationNormalized, incoming: RecordUiRepresentationNormalized): boolean;
export declare const ingest: $64$luvio_engine_ResourceIngest;
export declare function getTypeCacheKeys(rootKeySet: $64$luvio_engine_DurableStoreKeyMetadataMap, luvio: $64$luvio_engine_Luvio, input: RecordUiRepresentation, fullPathFactory: () => string | $64$luvio_engine_NormalizedKeyMetadata): void;
export declare function dynamicIngest(ingestParams: DynamicIngestParams): $64$luvio_engine_ResourceIngest;
/**
 * Record ui.
 *
 * Keys:
 *    (none)
 */
export interface RecordUiRepresentationNormalized {
    /** ETag like field, readOnly, handy while caching. */
    eTag: string;
    /** Map of layout ID -> user state. */
    layoutUserStates: {
        [key: string]: $64$luvio_engine_StoreLink;
    };
    /** Record layout. */
    layouts: {
        [key: string]: {
            [key: string]: {
                [key: string]: {
                    [key: string]: $64$luvio_engine_StoreLink;
                };
            };
        };
    };
    /** Object metadata. */
    objectInfos: {
        [key: string]: $64$luvio_engine_StoreLink;
    };
    /** Record data. */
    records: {
        [key: string]: $64$luvio_engine_StoreLink;
    };
}
/**
 * Record ui.
 *
 * Keys:
 *    (none)
 */
export interface RecordUiRepresentation {
    eTag: string;
    layoutUserStates: {
        [key: string]: RecordLayoutUserStateRepresentation_RecordLayoutUserStateRepresentation;
    };
    layouts: {
        [key: string]: {
            [key: string]: {
                [key: string]: {
                    [key: string]: RecordLayoutRepresentation_RecordLayoutRepresentation;
                };
            };
        };
    };
    objectInfos: {
        [key: string]: ObjectInfoRepresentation_ObjectInfoRepresentation;
    };
    records: {
        [key: string]: RecordRepresentation_RecordRepresentation;
    };
}
