import { IngestPath as $64$luvio_engine_IngestPath, Luvio as $64$luvio_engine_Luvio, Store as $64$luvio_engine_Store, FragmentSelection as $64$luvio_engine_FragmentSelection, ResourceIngest as $64$luvio_engine_ResourceIngest, DurableStoreKeyMetadataMap as $64$luvio_engine_DurableStoreKeyMetadataMap, NormalizedKeyMetadata as $64$luvio_engine_NormalizedKeyMetadata } from '@luvio/engine';
export declare const VERSION = "c3eaa462b65aea19ea1fad8cbe2688ba";
export declare function validate(obj: any, path?: string): TypeError | null;
export declare const RepresentationType: string;
export declare function normalize(input: RelatedListColumnRepresentation, existing: RelatedListColumnRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number): RelatedListColumnRepresentationNormalized;
export declare const select: () => $64$luvio_engine_FragmentSelection;
export declare function equals(existing: RelatedListColumnRepresentationNormalized, incoming: RelatedListColumnRepresentationNormalized): boolean;
export declare const ingest: $64$luvio_engine_ResourceIngest;
export declare function getTypeCacheKeys(rootKeySet: $64$luvio_engine_DurableStoreKeyMetadataMap, luvio: $64$luvio_engine_Luvio, input: RelatedListColumnRepresentation, fullPathFactory: () => string | $64$luvio_engine_NormalizedKeyMetadata): void;
/**
 * RelatedListColumnRepresentation
 *
 * Keys:
 *    (none)
 */
export interface RelatedListColumnRepresentationNormalized {
    /** The type of the column. */
    dataType: string | null;
    /** API name for the field. */
    fieldApiName: string;
    /** Whether the list column is filterable. */
    filterable: boolean | null;
    /** Label of the field. */
    label: string;
    /** The lookupId for the column when the field is a reference, otherwise null. */
    lookupId: string | null;
    /** The picklist values for this column (or null if the column is not a picklist). */
    picklistValues: Array<{
        [key: string]: string;
    }>;
    /** The operator to use for quick filters on this column. */
    quickFilterOperator: string | null;
    /** Whether the list column is sortable. */
    sortable: boolean;
}
/**
 * RelatedListColumnRepresentation
 *
 * Keys:
 *    (none)
 */
export interface RelatedListColumnRepresentation {
    dataType: string | null;
    fieldApiName: string;
    filterable: boolean | null;
    label: string;
    lookupId: string | null;
    picklistValues: Array<{
        [key: string]: string;
    }>;
    quickFilterOperator: string | null;
    sortable: boolean;
}
