import { RelatedListColumnRepresentation as RelatedListColumnRepresentation_RelatedListColumnRepresentation } from './RelatedListColumnRepresentation';
import { ListFilterByInfoRepresentation as ListFilterByInfoRepresentation_ListFilterByInfoRepresentation } from './ListFilterByInfoRepresentation';
import { RelatedListReferenceRepresentation as RelatedListReferenceRepresentation_RelatedListReferenceRepresentation } from './RelatedListReferenceRepresentation';
import { ListOrderByInfoRepresentation as ListOrderByInfoRepresentation_ListOrderByInfoRepresentation } from './ListOrderByInfoRepresentation';
import { ListUserPreferenceRepresentation as ListUserPreferenceRepresentation_ListUserPreferenceRepresentation } from './ListUserPreferenceRepresentation';
import { KeyMetadata as $64$luvio_engine_KeyMetadata, NormalizedKeyMetadata as $64$luvio_engine_NormalizedKeyMetadata, Luvio as $64$luvio_engine_Luvio, IngestPath as $64$luvio_engine_IngestPath, Store as $64$luvio_engine_Store, BaseFragment as $64$luvio_engine_BaseFragment, ResourceIngest as $64$luvio_engine_ResourceIngest, DurableStoreKeyMetadataMap as $64$luvio_engine_DurableStoreKeyMetadataMap } from '@luvio/engine';
export declare const TTL = 900000;
export declare const VERSION = "c977d65d153a2b4e888ddd45fb083248";
export declare function validate(obj: any, path?: string): TypeError | null;
export declare const RepresentationType: string;
export interface KeyParams extends $64$luvio_engine_KeyMetadata {
    relatedListId: string;
    parentObjectApiName: string;
    restrictColumnsToLayout: boolean;
    recordTypeId: string | null;
    optionalFields: Array<string>;
    fields: Array<string>;
}
export type RelatedListInfoRepresentationNormalizedKeyMetadata = KeyParams & $64$luvio_engine_NormalizedKeyMetadata;
export type PartialRelatedListInfoRepresentationNormalizedKeyMetadata = Partial<KeyParams> & $64$luvio_engine_NormalizedKeyMetadata;
export declare function keyBuilder(luvio: $64$luvio_engine_Luvio, config: KeyParams): string;
export declare function keyBuilder_StructuredKey(luvio: $64$luvio_engine_Luvio, config: KeyParams): RelatedListInfoRepresentationNormalizedKeyMetadata;
export declare function keyBuilderFromType(luvio: $64$luvio_engine_Luvio, object: RelatedListInfoRepresentation): string;
export declare function keyBuilderFromType_StructuredKey(luvio: $64$luvio_engine_Luvio, object: RelatedListInfoRepresentation): $64$luvio_engine_NormalizedKeyMetadata;
export declare function normalize(input: RelatedListInfoRepresentation, existing: RelatedListInfoRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number): RelatedListInfoRepresentationNormalized;
export declare const select: () => $64$luvio_engine_BaseFragment;
export declare function equals(existing: RelatedListInfoRepresentationNormalized, incoming: RelatedListInfoRepresentationNormalized): boolean;
export declare const ingest: $64$luvio_engine_ResourceIngest;
export declare function getTypeCacheKeys(rootKeySet: $64$luvio_engine_DurableStoreKeyMetadataMap, luvio: $64$luvio_engine_Luvio, input: RelatedListInfoRepresentation, fullPathFactory: () => string | $64$luvio_engine_NormalizedKeyMetadata): void;
/**
 * RelatedListInfoRepresentation
 *
 * Keys:
 *    relatedListId (string): listReference.relatedListId
 *    parentObjectApiName (string): listReference.parentObjectApiName
 *    restrictColumnsToLayout (boolean): restrictColumnsToLayout
 *    recordTypeId (string | null): listReference.recordTypeId
 *    optionalFields (Array<string>): optionalFields
 *    fields (Array<string>): fields
 */
export interface RelatedListInfoRepresentationNormalized {
    /** Indicates whether the listview can be cloned. */
    cloneable: boolean;
    /** Indicates whether a new listview for this listview's SObject can be created. */
    createable: boolean;
    /** Indicates whether the listview can be deleted. */
    deletable: boolean;
    /** All display columns for this list view. */
    displayColumns: Array<RelatedListColumnRepresentation_RelatedListColumnRepresentation>;
    /** ETag like field, readOnly, handy while caching. */
    eTag: string;
    /** The API name of the field in the child entity that links to the parent entity. */
    fieldApiName: string;
    /** The list of fields requested when this metadata was fetched. */
    fields: Array<string>;
    /** This is the filter logic such as "(1 OR 2) and 3".  Indexes are 1-based. */
    filterLogicString: string;
    /** The value to determine quickFilter support on layout based RelatedLists */
    filterable: boolean;
    /** Describes how the list view is filtered. */
    filteredByInfo: Array<ListFilterByInfoRepresentation_ListFilterByInfoRepresentation>;
    /** The list view's display label.  E.g. "All Accounts". */
    label: string;
    listReference: RelatedListReferenceRepresentation_RelatedListReferenceRepresentation;
    /** The API name of any objects that are returned by this relatedList. */
    objectApiNames: Array<string>;
    /** The list of optional fields requested when this metadata was fetched. */
    optionalFields: Array<string>;
    /** Describes how records are ordered in this list view. */
    orderedByInfo: Array<ListOrderByInfoRepresentation_ListOrderByInfoRepresentation>;
    /** The value for getRestrictColumnsToLayout requested when this metadata was fetched. */
    restrictColumnsToLayout: boolean;
    /** Indicates whether the listview can be updated. */
    updateable: boolean;
    /** All user preferences for this list view. */
    userPreferences: ListUserPreferenceRepresentation_ListUserPreferenceRepresentation;
    /** The list view's visibility. */
    visibility: string;
    /** Indicates whether the visibility of the listview can be edited. */
    visibilityEditable: boolean;
}
/**
 * RelatedListInfoRepresentation
 *
 * Keys:
 *    relatedListId (string): listReference.relatedListId
 *    parentObjectApiName (string): listReference.parentObjectApiName
 *    restrictColumnsToLayout (boolean): restrictColumnsToLayout
 *    recordTypeId (string | null): listReference.recordTypeId
 *    optionalFields (Array<string>): optionalFields
 *    fields (Array<string>): fields
 */
export interface RelatedListInfoRepresentation {
    cloneable: boolean;
    createable: boolean;
    deletable: boolean;
    displayColumns: Array<RelatedListColumnRepresentation_RelatedListColumnRepresentation>;
    eTag: string;
    fieldApiName: string;
    fields: Array<string>;
    filterLogicString: string;
    filterable: boolean;
    filteredByInfo: Array<ListFilterByInfoRepresentation_ListFilterByInfoRepresentation>;
    label: string;
    listReference: RelatedListReferenceRepresentation_RelatedListReferenceRepresentation;
    objectApiNames: Array<string>;
    optionalFields: Array<string>;
    orderedByInfo: Array<ListOrderByInfoRepresentation_ListOrderByInfoRepresentation>;
    restrictColumnsToLayout: boolean;
    updateable: boolean;
    userPreferences: ListUserPreferenceRepresentation_ListUserPreferenceRepresentation;
    visibility: string;
    visibilityEditable: boolean;
}
