import { IngestPath as $64$luvio_engine_IngestPath, Luvio as $64$luvio_engine_Luvio, Store as $64$luvio_engine_Store, FragmentSelection as $64$luvio_engine_FragmentSelection, ResourceIngest as $64$luvio_engine_ResourceIngest, DurableStoreKeyMetadataMap as $64$luvio_engine_DurableStoreKeyMetadataMap, NormalizedKeyMetadata as $64$luvio_engine_NormalizedKeyMetadata } from '@luvio/engine';
export declare const VERSION = "95b1f456aeb29e9be11ee2da32bb5e71";
export declare function validate(obj: any, path?: string): TypeError | null;
export declare const RepresentationType: string;
export declare function normalize(input: RelatedListRecordsSingleBatchInputRepresentation, existing: RelatedListRecordsSingleBatchInputRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number): RelatedListRecordsSingleBatchInputRepresentationNormalized;
export declare const select: () => $64$luvio_engine_FragmentSelection;
export declare function equals(existing: RelatedListRecordsSingleBatchInputRepresentationNormalized, incoming: RelatedListRecordsSingleBatchInputRepresentationNormalized): boolean;
export declare const ingest: $64$luvio_engine_ResourceIngest;
export declare function getTypeCacheKeys(rootKeySet: $64$luvio_engine_DurableStoreKeyMetadataMap, luvio: $64$luvio_engine_Luvio, input: RelatedListRecordsSingleBatchInputRepresentation, fullPathFactory: () => string | $64$luvio_engine_NormalizedKeyMetadata): void;
/**
 * Query (using POST) for records in multiple related lists.
 *
 * Keys:
 *    (none)
 */
export interface RelatedListRecordsSingleBatchInputRepresentationNormalized {
    /** Additional fields queried for the records returned.  If the field is not available to the user, an error occurs. */
    fields?: Array<string>;
    /** Additional fields queried for the records returned.  If the field is not available to the user, no error occurs and the field isn’t included in the records. */
    optionalFields?: Array<string>;
    /** The number of list records viewed at one time.  The default value is 50. Value can be 1–2000. */
    pageSize?: number;
    /** The identifier for this related list. */
    relatedListId: string;
    /** The API name of the field the related list is sorted by.  If the name is preceded with -, the sort order is descending. */
    sortBy?: Array<string>;
    /** Filter the records returned.  The value is in GraphQL syntax. */
    where?: string;
}
/**
 * Query (using POST) for records in multiple related lists.
 *
 * Keys:
 *    (none)
 */
export interface RelatedListRecordsSingleBatchInputRepresentation {
    fields?: Array<string>;
    optionalFields?: Array<string>;
    pageSize?: number;
    relatedListId: string;
    sortBy?: Array<string>;
    where?: string;
}
