import { RelatedListSummaryInfoRepresentation as RelatedListSummaryInfoRepresentation_RelatedListSummaryInfoRepresentation } from './RelatedListSummaryInfoRepresentation';
import { KeyMetadata as $64$luvio_engine_KeyMetadata, NormalizedKeyMetadata as $64$luvio_engine_NormalizedKeyMetadata, Luvio as $64$luvio_engine_Luvio, IngestPath as $64$luvio_engine_IngestPath, Store as $64$luvio_engine_Store, BaseFragment as $64$luvio_engine_BaseFragment, ResourceIngest as $64$luvio_engine_ResourceIngest, DurableStoreKeyMetadataMap as $64$luvio_engine_DurableStoreKeyMetadataMap } from '@luvio/engine';
export declare const VERSION = "2a1722afba0e1ee52d6b7b0a25ccd9f4";
export declare function validate(obj: any, path?: string): TypeError | null;
export declare const RepresentationType: string;
export interface KeyParams extends $64$luvio_engine_KeyMetadata {
    parentObjectApiName: string;
    recordTypeId: string | null;
}
export type RelatedListSummaryInfoCollectionRepresentationNormalizedKeyMetadata = KeyParams & $64$luvio_engine_NormalizedKeyMetadata;
export type PartialRelatedListSummaryInfoCollectionRepresentationNormalizedKeyMetadata = Partial<KeyParams> & $64$luvio_engine_NormalizedKeyMetadata;
export declare function keyBuilder(luvio: $64$luvio_engine_Luvio, config: KeyParams): string;
export declare function keyBuilder_StructuredKey(luvio: $64$luvio_engine_Luvio, config: KeyParams): RelatedListSummaryInfoCollectionRepresentationNormalizedKeyMetadata;
export declare function keyBuilderFromType(luvio: $64$luvio_engine_Luvio, object: RelatedListSummaryInfoCollectionRepresentation): string;
export declare function keyBuilderFromType_StructuredKey(luvio: $64$luvio_engine_Luvio, object: RelatedListSummaryInfoCollectionRepresentation): $64$luvio_engine_NormalizedKeyMetadata;
export declare function normalize(input: RelatedListSummaryInfoCollectionRepresentation, existing: RelatedListSummaryInfoCollectionRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number): RelatedListSummaryInfoCollectionRepresentationNormalized;
export declare const select: () => $64$luvio_engine_BaseFragment;
export declare function equals(existing: RelatedListSummaryInfoCollectionRepresentationNormalized, incoming: RelatedListSummaryInfoCollectionRepresentationNormalized): boolean;
export declare const ingest: $64$luvio_engine_ResourceIngest;
export declare function getTypeCacheKeys(rootKeySet: $64$luvio_engine_DurableStoreKeyMetadataMap, luvio: $64$luvio_engine_Luvio, input: RelatedListSummaryInfoCollectionRepresentation, fullPathFactory: () => string | $64$luvio_engine_NormalizedKeyMetadata): void;
/**
 * Information about a collection of related lists that all have the same parent type.
 *
 * Keys:
 *    parentObjectApiName (string): parentObjectApiName
 *    recordTypeId (string | null): parentRecordTypeId
 */
export interface RelatedListSummaryInfoCollectionRepresentationNormalized {
    /** ETag like field, readOnly, handy while caching. */
    eTag: string;
    /** The API name of the parent object. */
    parentObjectApiName: string;
    /** The record type id of the parent. */
    parentRecordTypeId: string | null;
    /** Summary information about the related lists. */
    relatedLists: Array<RelatedListSummaryInfoRepresentation_RelatedListSummaryInfoRepresentation>;
}
/**
 * Information about a collection of related lists that all have the same parent type.
 *
 * Keys:
 *    parentObjectApiName (string): parentObjectApiName
 *    recordTypeId (string | null): parentRecordTypeId
 */
export interface RelatedListSummaryInfoCollectionRepresentation {
    eTag: string;
    parentObjectApiName: string;
    parentRecordTypeId: string | null;
    relatedLists: Array<RelatedListSummaryInfoRepresentation_RelatedListSummaryInfoRepresentation>;
}
