import { ThemeInfoRepresentation as ThemeInfoRepresentation_ThemeInfoRepresentation } from './ThemeInfoRepresentation';
import { IngestPath as $64$luvio_engine_IngestPath, Luvio as $64$luvio_engine_Luvio, Store as $64$luvio_engine_Store, FragmentSelection as $64$luvio_engine_FragmentSelection, ResourceIngest as $64$luvio_engine_ResourceIngest, DurableStoreKeyMetadataMap as $64$luvio_engine_DurableStoreKeyMetadataMap, NormalizedKeyMetadata as $64$luvio_engine_NormalizedKeyMetadata } from '@luvio/engine';
export declare const VERSION = "fe8b72b08a1f7d8af7adaba7904e4cb4";
export declare function validate(obj: any, path?: string): TypeError | null;
export declare const RepresentationType: string;
export declare function normalize(input: RelatedListSummaryInfoRepresentation, existing: RelatedListSummaryInfoRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number): RelatedListSummaryInfoRepresentationNormalized;
export declare const select: () => $64$luvio_engine_FragmentSelection;
export declare function equals(existing: RelatedListSummaryInfoRepresentationNormalized, incoming: RelatedListSummaryInfoRepresentationNormalized): boolean;
export declare const ingest: $64$luvio_engine_ResourceIngest;
export declare function getTypeCacheKeys(rootKeySet: $64$luvio_engine_DurableStoreKeyMetadataMap, luvio: $64$luvio_engine_Luvio, input: RelatedListSummaryInfoRepresentation, fullPathFactory: () => string | $64$luvio_engine_NormalizedKeyMetadata): void;
/**
 * RelatedListSummaryInfoRepresentation
 *
 * Keys:
 *    (none)
 */
export interface RelatedListSummaryInfoRepresentationNormalized {
    /** The label for this related list's entity. */
    entityLabel: string;
    /** The plural label for this related list's entity. */
    entityPluralLabel: string;
    /** The API name of the field in the child entity that links to the parent entity. */
    fieldApiName: string;
    /** The key prefix for IDs of the object that populates the list.  This can be null for some related lists. */
    keyPrefix: string | null;
    /** The label for the related list. */
    label: string;
    /** The API name of the this object. */
    objectApiName: string;
    /** Points to the parent’s field name that provides the id. */
    parentFieldApiName: string;
    /** The id of the related list. */
    relatedListId: string;
    /** The URL to fetch the metadata for the related list. */
    relatedListInfoUrl: string | null;
    /** The theme info for this related list's entity. */
    themeInfo: ThemeInfoRepresentation_ThemeInfoRepresentation | null;
    /** True if the elements in the layout are supported in UI API.  This is a best effort calculation, and should not be relied upon to always be completely accurate. */
    uiApiEnabledLayout: boolean;
}
/**
 * RelatedListSummaryInfoRepresentation
 *
 * Keys:
 *    (none)
 */
export interface RelatedListSummaryInfoRepresentation {
    entityLabel: string;
    entityPluralLabel: string;
    fieldApiName: string;
    keyPrefix: string | null;
    label: string;
    objectApiName: string;
    parentFieldApiName: string;
    relatedListId: string;
    relatedListInfoUrl: string | null;
    themeInfo: ThemeInfoRepresentation_ThemeInfoRepresentation | null;
    uiApiEnabledLayout: boolean;
}
