import { AbstractRecordLayoutComponentRepresentation as AbstractRecordLayoutComponentRepresentation_AbstractRecordLayoutComponentRepresentation } from './AbstractRecordLayoutComponentRepresentation';
import { IngestPath as $64$luvio_engine_IngestPath, Luvio as $64$luvio_engine_Luvio, Store as $64$luvio_engine_Store, FragmentSelection as $64$luvio_engine_FragmentSelection, ResourceIngest as $64$luvio_engine_ResourceIngest, DurableStoreKeyMetadataMap as $64$luvio_engine_DurableStoreKeyMetadataMap, NormalizedKeyMetadata as $64$luvio_engine_NormalizedKeyMetadata } from '@luvio/engine';
export declare const VERSION = "ea916ba00c634742ca361fa09cf324a9";
export declare function validate(obj: any, path?: string): TypeError | null;
export declare const RepresentationType: string;
export declare function normalize(input: ReportLayoutComponentRepresentation, existing: ReportLayoutComponentRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number): ReportLayoutComponentRepresentationNormalized;
export declare const select: () => $64$luvio_engine_FragmentSelection;
export declare function equals(existing: ReportLayoutComponentRepresentationNormalized, incoming: ReportLayoutComponentRepresentationNormalized): boolean;
export declare const ingest: $64$luvio_engine_ResourceIngest;
export declare function getTypeCacheKeys(rootKeySet: $64$luvio_engine_DurableStoreKeyMetadataMap, luvio: $64$luvio_engine_Luvio, input: ReportLayoutComponentRepresentation, fullPathFactory: () => string | $64$luvio_engine_NormalizedKeyMetadata): void;
/**
 * Report record layout component.
 *
 * Keys:
 *    (none)
 */
export interface ReportLayoutComponentRepresentationNormalized extends AbstractRecordLayoutComponentRepresentation_AbstractRecordLayoutComponentRepresentation {
    /** Cache data */
    cacheData: boolean;
    /** Error */
    error: string;
    /** Filter */
    filter: string;
    /** Hide on error */
    hideOnError: boolean;
    /** Placeholder */
    placeholder: string;
    /** Report ID */
    reportId: string;
    /** Show title */
    showTitle: boolean;
    /** Size */
    size: string;
}
/**
 * Report record layout component.
 *
 * Keys:
 *    (none)
 */
export interface ReportLayoutComponentRepresentation extends AbstractRecordLayoutComponentRepresentation_AbstractRecordLayoutComponentRepresentation {
    cacheData: boolean;
    error: string;
    filter: string;
    hideOnError: boolean;
    placeholder: string;
    reportId: string;
    showTitle: boolean;
    size: string;
    componentType: 'ReportChart';
}
