import { AppliedSearchFilterOutputRepresentation as AppliedSearchFilterOutputRepresentation_AppliedSearchFilterOutputRepresentation } from './AppliedSearchFilterOutputRepresentation';
import { SearchAnswersRecordRepresentation as SearchAnswersRecordRepresentation_SearchAnswersRecordRepresentation } from './SearchAnswersRecordRepresentation';
import { IngestPath as $64$luvio_engine_IngestPath, Luvio as $64$luvio_engine_Luvio, Store as $64$luvio_engine_Store, FragmentSelection as $64$luvio_engine_FragmentSelection, ResourceIngest as $64$luvio_engine_ResourceIngest, DurableStoreKeyMetadataMap as $64$luvio_engine_DurableStoreKeyMetadataMap, NormalizedKeyMetadata as $64$luvio_engine_NormalizedKeyMetadata } from '@luvio/engine';
export declare const VERSION = "f47e7ae3d6c34994e631df9eb35c9de1";
export declare function validate(obj: any, path?: string): TypeError | null;
export declare const RepresentationType: string;
export declare function normalize(input: SearchAnswersResultRepresentation, existing: SearchAnswersResultRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number): SearchAnswersResultRepresentationNormalized;
export declare const select: () => $64$luvio_engine_FragmentSelection;
export declare function equals(existing: SearchAnswersResultRepresentationNormalized, incoming: SearchAnswersResultRepresentationNormalized): boolean;
export declare const ingest: $64$luvio_engine_ResourceIngest;
export declare function getTypeCacheKeys(rootKeySet: $64$luvio_engine_DurableStoreKeyMetadataMap, luvio: $64$luvio_engine_Luvio, input: SearchAnswersResultRepresentation, fullPathFactory: () => string | $64$luvio_engine_NormalizedKeyMetadata): void;
/**
 * Search Answers Response
 *
 * Keys:
 *    (none)
 */
export interface SearchAnswersResultRepresentationNormalized {
    /** The type of search answer */
    answerType: string | null;
    /** The list of applied filters. */
    appliedFilters: Array<AppliedSearchFilterOutputRepresentation_AppliedSearchFilterOutputRepresentation>;
    /** The record's llmGenerationId */
    llmGenerationId: string | null;
    /** The record’s snippet which includes the answer */
    passage: string | null;
    /** The list of records for search answer */
    records: Array<SearchAnswersRecordRepresentation_SearchAnswersRecordRepresentation>;
}
/**
 * Search Answers Response
 *
 * Keys:
 *    (none)
 */
export interface SearchAnswersResultRepresentation {
    answerType: string | null;
    appliedFilters: Array<AppliedSearchFilterOutputRepresentation_AppliedSearchFilterOutputRepresentation>;
    llmGenerationId: string | null;
    passage: string | null;
    records: Array<SearchAnswersRecordRepresentation_SearchAnswersRecordRepresentation>;
}
