import { SearchFilterOptionRepresentation as SearchFilterOptionRepresentation_SearchFilterOptionRepresentation } from './SearchFilterOptionRepresentation';
import { KeyMetadata as $64$luvio_engine_KeyMetadata, NormalizedKeyMetadata as $64$luvio_engine_NormalizedKeyMetadata, Luvio as $64$luvio_engine_Luvio, IngestPath as $64$luvio_engine_IngestPath, Store as $64$luvio_engine_Store, BaseFragment as $64$luvio_engine_BaseFragment, ResourceIngest as $64$luvio_engine_ResourceIngest, DurableStoreKeyMetadataMap as $64$luvio_engine_DurableStoreKeyMetadataMap } from '@luvio/engine';
export declare const TTL = 30000;
export declare const VERSION = "8d851a8d9abf0a061a8ad81d4cbb83bc";
export declare function validate(obj: any, path?: string): TypeError | null;
export declare const RepresentationType: string;
export interface KeyParams extends $64$luvio_engine_KeyMetadata {
    query: string | null;
    objectApiName: string;
    filterApiName: string;
}
export type SearchFilterOptionCollectionRepresentationNormalizedKeyMetadata = KeyParams & $64$luvio_engine_NormalizedKeyMetadata;
export type PartialSearchFilterOptionCollectionRepresentationNormalizedKeyMetadata = Partial<KeyParams> & $64$luvio_engine_NormalizedKeyMetadata;
export declare function keyBuilder(luvio: $64$luvio_engine_Luvio, config: KeyParams): string;
export declare function keyBuilder_StructuredKey(luvio: $64$luvio_engine_Luvio, config: KeyParams): SearchFilterOptionCollectionRepresentationNormalizedKeyMetadata;
export declare function keyBuilderFromType(luvio: $64$luvio_engine_Luvio, object: SearchFilterOptionCollectionRepresentation): string;
export declare function keyBuilderFromType_StructuredKey(luvio: $64$luvio_engine_Luvio, object: SearchFilterOptionCollectionRepresentation): $64$luvio_engine_NormalizedKeyMetadata;
export declare function normalize(input: SearchFilterOptionCollectionRepresentation, existing: SearchFilterOptionCollectionRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number): SearchFilterOptionCollectionRepresentationNormalized;
export declare const select: () => $64$luvio_engine_BaseFragment;
export declare function equals(existing: SearchFilterOptionCollectionRepresentationNormalized, incoming: SearchFilterOptionCollectionRepresentationNormalized): boolean;
export declare const ingest: $64$luvio_engine_ResourceIngest;
export declare function getTypeCacheKeys(rootKeySet: $64$luvio_engine_DurableStoreKeyMetadataMap, luvio: $64$luvio_engine_Luvio, input: SearchFilterOptionCollectionRepresentation, fullPathFactory: () => string | $64$luvio_engine_NormalizedKeyMetadata): void;
/**
 * Search filter options response.
 *
 * Keys:
 *    query (string | null): query
 *    objectApiName (string): objectApiName
 *    filterApiName (string): filterApiName
 */
export interface SearchFilterOptionCollectionRepresentationNormalized {
    /** Api name of the filter field to get filter options. */
    filterApiName: string;
    /** Api name of the object with filter field */
    objectApiName: string;
    /** List of search filter options to be displayed in the filter field. */
    options: Array<SearchFilterOptionRepresentation_SearchFilterOptionRepresentation>;
    /** Search query that yielded the search results */
    query: string | null;
}
/**
 * Search filter options response.
 *
 * Keys:
 *    query (string | null): query
 *    objectApiName (string): objectApiName
 *    filterApiName (string): filterApiName
 */
export interface SearchFilterOptionCollectionRepresentation {
    filterApiName: string;
    objectApiName: string;
    options: Array<SearchFilterOptionRepresentation_SearchFilterOptionRepresentation>;
    query: string | null;
}
