import { SearchDataCategoryOutputRepresentation as SearchDataCategoryOutputRepresentation_SearchDataCategoryOutputRepresentation } from './SearchDataCategoryOutputRepresentation';
import { SearchFilterOutputRepresentation as SearchFilterOutputRepresentation_SearchFilterOutputRepresentation } from './SearchFilterOutputRepresentation';
import { IngestPath as $64$luvio_engine_IngestPath, Luvio as $64$luvio_engine_Luvio, Store as $64$luvio_engine_Store, FragmentSelection as $64$luvio_engine_FragmentSelection, ResourceIngest as $64$luvio_engine_ResourceIngest, DurableStoreKeyMetadataMap as $64$luvio_engine_DurableStoreKeyMetadataMap, NormalizedKeyMetadata as $64$luvio_engine_NormalizedKeyMetadata } from '@luvio/engine';
export declare const VERSION = "de195c61e2bd28d1656f4f9603ce6d27";
export declare function validate(obj: any, path?: string): TypeError | null;
export declare const RepresentationType: string;
export declare function normalize(input: SearchObjectOptionsOutputRepresentation, existing: SearchObjectOptionsOutputRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number): SearchObjectOptionsOutputRepresentationNormalized;
export declare const select: () => $64$luvio_engine_FragmentSelection;
export declare function equals(existing: SearchObjectOptionsOutputRepresentationNormalized, incoming: SearchObjectOptionsOutputRepresentationNormalized): boolean;
export declare const ingest: $64$luvio_engine_ResourceIngest;
export declare function getTypeCacheKeys(rootKeySet: $64$luvio_engine_DurableStoreKeyMetadataMap, luvio: $64$luvio_engine_Luvio, input: SearchObjectOptionsOutputRepresentation, fullPathFactory: () => string | $64$luvio_engine_NormalizedKeyMetadata): void;
/**
 * search object options like filters and data categories
 *
 * Keys:
 *    (none)
 */
export interface SearchObjectOptionsOutputRepresentationNormalized {
    /** List of Data categories applied */
    dataCategories: Array<SearchDataCategoryOutputRepresentation_SearchDataCategoryOutputRepresentation>;
    /** List of filters applied */
    filters: Array<SearchFilterOutputRepresentation_SearchFilterOutputRepresentation>;
}
/**
 * search object options like filters and data categories
 *
 * Keys:
 *    (none)
 */
export interface SearchObjectOptionsOutputRepresentation {
    dataCategories: Array<SearchDataCategoryOutputRepresentation_SearchDataCategoryOutputRepresentation>;
    filters: Array<SearchFilterOutputRepresentation_SearchFilterOutputRepresentation>;
}
