import { SearchDataCategoryInputRepresentation as SearchDataCategoryInputRepresentation_SearchDataCategoryInputRepresentation } from './SearchDataCategoryInputRepresentation';
import { SearchFilterInputRepresentation as SearchFilterInputRepresentation_SearchFilterInputRepresentation } from './SearchFilterInputRepresentation';
import { IngestPath as $64$luvio_engine_IngestPath, Luvio as $64$luvio_engine_Luvio, Store as $64$luvio_engine_Store, FragmentSelection as $64$luvio_engine_FragmentSelection, ResourceIngest as $64$luvio_engine_ResourceIngest, DurableStoreKeyMetadataMap as $64$luvio_engine_DurableStoreKeyMetadataMap, NormalizedKeyMetadata as $64$luvio_engine_NormalizedKeyMetadata } from '@luvio/engine';
export declare const VERSION = "779d7cafc5ae45253068affa652ed120";
export declare function validate(obj: any, path?: string): TypeError | null;
export declare const RepresentationType: string;
export declare function normalize(input: SearchObjectOptionsRepresentation, existing: SearchObjectOptionsRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number): SearchObjectOptionsRepresentationNormalized;
export declare const select: () => $64$luvio_engine_FragmentSelection;
export declare function equals(existing: SearchObjectOptionsRepresentationNormalized, incoming: SearchObjectOptionsRepresentationNormalized): boolean;
export declare const ingest: $64$luvio_engine_ResourceIngest;
export declare function getTypeCacheKeys(rootKeySet: $64$luvio_engine_DurableStoreKeyMetadataMap, luvio: $64$luvio_engine_Luvio, input: SearchObjectOptionsRepresentation, fullPathFactory: () => string | $64$luvio_engine_NormalizedKeyMetadata): void;
/**
 * Input parameters for search object options
 *
 * Keys:
 *    (none)
 */
export interface SearchObjectOptionsRepresentationNormalized {
    /** Data Categories to apply on our results */
    dataCategories: Array<SearchDataCategoryInputRepresentation_SearchDataCategoryInputRepresentation>;
    /** Filters to apply on our results */
    filters: Array<SearchFilterInputRepresentation_SearchFilterInputRepresentation>;
}
/**
 * Input parameters for search object options
 *
 * Keys:
 *    (none)
 */
export interface SearchObjectOptionsRepresentation {
    dataCategories: Array<SearchDataCategoryInputRepresentation_SearchDataCategoryInputRepresentation>;
    filters: Array<SearchFilterInputRepresentation_SearchFilterInputRepresentation>;
}
