import { IngestPath as $64$luvio_engine_IngestPath, Luvio as $64$luvio_engine_Luvio, Store as $64$luvio_engine_Store, FragmentSelection as $64$luvio_engine_FragmentSelection, ResourceIngest as $64$luvio_engine_ResourceIngest, DurableStoreKeyMetadataMap as $64$luvio_engine_DurableStoreKeyMetadataMap, NormalizedKeyMetadata as $64$luvio_engine_NormalizedKeyMetadata } from '@luvio/engine';
export declare const VERSION = "cb1cfeddedbb84c1b38aeb5d3548a79b";
export declare function validate(obj: any, path?: string): TypeError | null;
export declare const RepresentationType: string;
export declare function normalize(input: SearchRecordInfoRepresentation, existing: SearchRecordInfoRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number): SearchRecordInfoRepresentationNormalized;
export declare const select: () => $64$luvio_engine_FragmentSelection;
export declare function equals(existing: SearchRecordInfoRepresentationNormalized, incoming: SearchRecordInfoRepresentationNormalized): boolean;
export declare const ingest: $64$luvio_engine_ResourceIngest;
export declare function getTypeCacheKeys(rootKeySet: $64$luvio_engine_DurableStoreKeyMetadataMap, luvio: $64$luvio_engine_Luvio, input: SearchRecordInfoRepresentation, fullPathFactory: () => string | $64$luvio_engine_NormalizedKeyMetadata): void;
/**
 * Record-level search information
 *
 * Keys:
 *    (none)
 */
export interface SearchRecordInfoRepresentationNormalized {
    /** Is the record promoted? */
    isPromoted: boolean | null;
    /** Did we find the record by applying the spell correction? */
    isSpellCorrected: boolean;
}
/**
 * Record-level search information
 *
 * Keys:
 *    (none)
 */
export interface SearchRecordInfoRepresentation {
    isPromoted: boolean | null;
    isSpellCorrected: boolean;
}
