import { KeywordSearchResultsRepresentation as KeywordSearchResultsRepresentation_KeywordSearchResultsRepresentation } from './KeywordSearchResultsRepresentation';
import { NLSResultsRepresentation as NLSResultsRepresentation_NLSResultsRepresentation } from './NLSResultsRepresentation';
import { SearchAnswersResultRepresentation as SearchAnswersResultRepresentation_SearchAnswersResultRepresentation } from './SearchAnswersResultRepresentation';
import { SearchObjectOptionsOutputRepresentation as SearchObjectOptionsOutputRepresentation_SearchObjectOptionsOutputRepresentation } from './SearchObjectOptionsOutputRepresentation';
import { KeyMetadata as $64$luvio_engine_KeyMetadata, NormalizedKeyMetadata as $64$luvio_engine_NormalizedKeyMetadata, Luvio as $64$luvio_engine_Luvio, IngestPath as $64$luvio_engine_IngestPath, Store as $64$luvio_engine_Store, BaseFragment as $64$luvio_engine_BaseFragment, ResourceIngest as $64$luvio_engine_ResourceIngest, StoreLink as $64$luvio_engine_StoreLink, DurableStoreKeyMetadataMap as $64$luvio_engine_DurableStoreKeyMetadataMap } from '@luvio/engine';
export declare const TTL = 200;
export declare const VERSION = "94ab97aedd252f899c90d52d898e547f";
export declare function validate(obj: any, path?: string): TypeError | null;
export declare const RepresentationType: string;
export interface KeyParams extends $64$luvio_engine_KeyMetadata {
    query: string;
    configurationName: string | null;
}
export type SearchResultsSummaryRepresentationNormalizedKeyMetadata = KeyParams & $64$luvio_engine_NormalizedKeyMetadata;
export type PartialSearchResultsSummaryRepresentationNormalizedKeyMetadata = Partial<KeyParams> & $64$luvio_engine_NormalizedKeyMetadata;
export declare function keyBuilder(luvio: $64$luvio_engine_Luvio, config: KeyParams): string;
export declare function keyBuilder_StructuredKey(luvio: $64$luvio_engine_Luvio, config: KeyParams): SearchResultsSummaryRepresentationNormalizedKeyMetadata;
export declare function keyBuilderFromType(luvio: $64$luvio_engine_Luvio, object: SearchResultsSummaryRepresentation): string;
export declare function keyBuilderFromType_StructuredKey(luvio: $64$luvio_engine_Luvio, object: SearchResultsSummaryRepresentation): $64$luvio_engine_NormalizedKeyMetadata;
export declare function normalize(input: SearchResultsSummaryRepresentation, existing: SearchResultsSummaryRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number): SearchResultsSummaryRepresentationNormalized;
export declare const select: () => $64$luvio_engine_BaseFragment;
export declare function equals(existing: SearchResultsSummaryRepresentationNormalized, incoming: SearchResultsSummaryRepresentationNormalized): boolean;
export declare const ingest: $64$luvio_engine_ResourceIngest;
export declare function getTypeCacheKeys(rootKeySet: $64$luvio_engine_DurableStoreKeyMetadataMap, luvio: $64$luvio_engine_Luvio, input: SearchResultsSummaryRepresentation, fullPathFactory: () => string | $64$luvio_engine_NormalizedKeyMetadata): void;
/**
 * Root of the search response
 *
 * Keys:
 *    query (string): query
 *    configurationName (string | null): configurationName
 */
export interface SearchResultsSummaryRepresentationNormalized {
    /** Configuration Name to be applied */
    configurationName: string | null;
    /** Keyword Search Results Response */
    keywordSearchResults: $64$luvio_engine_StoreLink | null;
    /** Natural Language Search Results Response */
    nlsResults: $64$luvio_engine_StoreLink | null;
    /** Search Answers Response */
    qnaResult: SearchAnswersResultRepresentation_SearchAnswersResultRepresentation | null;
    /** Search query that yielded the search results */
    query: string;
    /** Search’s request ID */
    queryId: string;
    /** Search object options applied */
    searchObjectOptions: {
        [key: string]: SearchObjectOptionsOutputRepresentation_SearchObjectOptionsOutputRepresentation;
    };
}
/**
 * Root of the search response
 *
 * Keys:
 *    query (string): query
 *    configurationName (string | null): configurationName
 */
export interface SearchResultsSummaryRepresentation {
    configurationName: string | null;
    keywordSearchResults: KeywordSearchResultsRepresentation_KeywordSearchResultsRepresentation | null;
    nlsResults: NLSResultsRepresentation_NLSResultsRepresentation | null;
    qnaResult: SearchAnswersResultRepresentation_SearchAnswersResultRepresentation | null;
    query: string;
    queryId: string;
    searchObjectOptions: {
        [key: string]: SearchObjectOptionsOutputRepresentation_SearchObjectOptionsOutputRepresentation;
    };
}
