import { AbstractPicklistValueAttributesRepresentation as AbstractPicklistValueAttributesRepresentation_AbstractPicklistValueAttributesRepresentation } from './AbstractPicklistValueAttributesRepresentation';
import { IngestPath as $64$luvio_engine_IngestPath, Luvio as $64$luvio_engine_Luvio, Store as $64$luvio_engine_Store, FragmentSelection as $64$luvio_engine_FragmentSelection, ResourceIngest as $64$luvio_engine_ResourceIngest, DurableStoreKeyMetadataMap as $64$luvio_engine_DurableStoreKeyMetadataMap, NormalizedKeyMetadata as $64$luvio_engine_NormalizedKeyMetadata } from '@luvio/engine';
export declare const VERSION = "8d2032474fb4fabdf5cf4042be9042d9";
export declare function validate(obj: any, path?: string): TypeError | null;
export declare const RepresentationType: string;
export declare function normalize(input: WorkStepPicklistValueAttributeRepresentation, existing: WorkStepPicklistValueAttributeRepresentationNormalized, path: $64$luvio_engine_IngestPath, luvio: $64$luvio_engine_Luvio, store: $64$luvio_engine_Store, timestamp: number): WorkStepPicklistValueAttributeRepresentationNormalized;
export declare const select: () => $64$luvio_engine_FragmentSelection;
export declare function equals(existing: WorkStepPicklistValueAttributeRepresentationNormalized, incoming: WorkStepPicklistValueAttributeRepresentationNormalized): boolean;
export declare const ingest: $64$luvio_engine_ResourceIngest;
export declare function getTypeCacheKeys(rootKeySet: $64$luvio_engine_DurableStoreKeyMetadataMap, luvio: $64$luvio_engine_Luvio, input: WorkStepPicklistValueAttributeRepresentation, fullPathFactory: () => string | $64$luvio_engine_NormalizedKeyMetadata): void;
/**
 * Additional picklist value attributes for WorkStep statuses.
 *
 * Keys:
 *    (none)
 */
export interface WorkStepPicklistValueAttributeRepresentationNormalized extends AbstractPicklistValueAttributesRepresentation_AbstractPicklistValueAttributesRepresentation {
    /** Indicate the order in which the work step statuses are displayed in the status category's picklist. For more info, see the doc for the WorkStepStatus standard object */
    sortOrder: number;
    /** Indicate the status category that this status belongs to. For more info, see the doc for the WorkStepStatus standard object */
    statusCode: string;
}
/**
 * Additional picklist value attributes for WorkStep statuses.
 *
 * Keys:
 *    (none)
 */
export interface WorkStepPicklistValueAttributeRepresentation extends AbstractPicklistValueAttributesRepresentation_AbstractPicklistValueAttributesRepresentation {
    sortOrder: number;
    statusCode: string;
    picklistAtrributesValueType: 'WorkStepStatus';
}
