import type { Luvio, Snapshot, StoreLookup, CoercedAdapterRequestContext, DispatchResourceRequestContext } from '@luvio/engine';
import type { AdapterValidationConfig } from '../../generated/adapters/adapter-utils';
import type { PicklistValuesRepresentation } from '../../generated/types/PicklistValuesRepresentation';
export interface GetPicklistValuesConfig {
    recordTypeId: string;
    fieldApiName: string;
}
export declare function buildNetworkSnapshot(luvio: Luvio, config: GetPicklistValuesConfig, options?: DispatchResourceRequestContext): Promise<Snapshot<PicklistValuesRepresentation>>;
export declare function buildCachedSnapshot(luvio: Luvio, config: GetPicklistValuesConfig): Snapshot<PicklistValuesRepresentation, unknown>;
type BuildSnapshotContext = {
    config: GetPicklistValuesConfig;
    luvio: Luvio;
};
export declare function buildNetworkSnapshotCachePolicy(context: BuildSnapshotContext, coercedAdapterRequestContext: CoercedAdapterRequestContext): Promise<Snapshot<PicklistValuesRepresentation, any>>;
export declare function buildCachedSnapshotCachePolicy(context: BuildSnapshotContext, storeLookup: StoreLookup<PicklistValuesRepresentation>): Snapshot<PicklistValuesRepresentation, any>;
export declare function validateAdapterConfig(untrusted: unknown, _config: AdapterValidationConfig): import("../../generated/adapters/getPicklistValues").GetPicklistValuesConfig | null;
export {};
