import type { PathSelection, StoreLink } from '@luvio/engine';
import type { FieldValueRepresentation } from '../generated/types/FieldValueRepresentation';
import type { RecordFieldTrie } from '../util/records';
export type FieldMapRepresentationNormalized = {
    apiName: string;
    fields: {
        [key: string]: StoreLink;
    };
};
export type FieldMapRepresentation = {
    apiName: string;
    fields: {
        [key: string]: FieldValueRepresentation;
    };
};
export declare const MAX_RECORD_DEPTH = 5;
export declare function convertRecordFieldsArrayToTrie(fields: string[], optionalFields?: string[]): RecordFieldTrie;
export declare function createPathSelection(propertyName: string, fieldDefinition: RecordFieldTrie): PathSelection;
/**
 * Convert a RecordRepresentationLike into its equivalent selection.
 */
export declare function createPathSelectionFromValue(fields: FieldMapRepresentation['fields']): PathSelection;
/**
 * Returns a list of fields for a RecordRepresentationLike.
 *
 * TODO [W-6900271]: Remove this function once getRelatedList don't depend on it anymore. Always prefer
 * generating a selection out of a record, than convert a record to a field list and back to a
 * selection.
 */
export declare function extractFields(value: FieldMapRepresentation): string[];
export declare function insertFieldsIntoTrie(root: RecordFieldTrie, fields: string[], optional?: boolean): void;
