export declare function isString(value: any): value is string;
/**
 * Converts a value to an array. If the value is null/undefined, an empty array is returned.
 * @param value The value to convert to an array.
 * @returns value if it's an array; an empty array if value is null/undefined; otherwise value wrapped in an array.
 */
export declare function toArray<T>(value: T | T[] | undefined): T[];
/**
 * @param value The array to inspect.
 * @returns True if the array is non-empty and contains only non-empty strings.
 */
export declare function isArrayOfNonEmptyStrings(value: any[]): value is string[];
/**
 * @param value The array to dedupe
 * @returns An array without duplicates.
 */
export declare function dedupe<T extends string>(value: T[]): T[];
/**
 * @param source The array of string to filter
 * @param compare The array to filter against
 * @returns An array with values from source that do not exist in compare
 * If the "compare" array is empty, "source" array itself is returned, not a shallow copy
 */
export declare function difference(source: string[], compare: string[]): string[];
/**
 * @param word The string to title case
 * @returns The sames string but in title case
 */
export declare function toTitleCase(word: string): string;
