import type { Luvio, Selector, Snapshot, SnapshotRefresh, FetchResponse, AdapterRequestContext, StoreLookup, DispatchResourceRequestContext, ErrorResponse, NormalizedKeyMetadata } from '@luvio/engine';
import type { GetRecordConfig } from '../../generated/adapters/getRecord';
import type { RecordRepresentation } from '../../generated/types/RecordRepresentation';
export declare function buildRecordSelector(luvio: Luvio, recordId: string, fields: string[], optionalFields: string[]): Selector;
export declare function ingestSuccess(luvio: Luvio, config: GetRecordConfig, key: string | NormalizedKeyMetadata, allTrackedFields: string[], response: FetchResponse<RecordRepresentation>, serverRequestCount: number): Snapshot<RecordRepresentation, unknown>;
export declare function ingestError(luvio: Luvio, config: GetRecordConfig, key: string | NormalizedKeyMetadata, err: ErrorResponse): import("@luvio/engine").ErrorSnapshot;
export declare function buildNetworkSnapshot(luvio: Luvio, config: GetRecordConfig, serverRequestCount?: number, options?: DispatchResourceRequestContext): Promise<import("@luvio/engine").ErrorSnapshot | import("@luvio/engine").FulfilledSnapshot<RecordRepresentation, unknown> | import("@luvio/engine").UnfulfilledSnapshot<RecordRepresentation, unknown> | import("@luvio/engine").StaleSnapshot<RecordRepresentation, unknown> | import("@luvio/engine").PendingSnapshot<RecordRepresentation, unknown>>;
export declare function buildCachedSnapshot(luvio: Luvio, config: GetRecordConfig, refresh?: SnapshotRefresh<RecordRepresentation>): Snapshot<RecordRepresentation, unknown>;
export type BuildSnapshotContext = {
    config: GetRecordConfig;
    luvio: Luvio;
};
export declare function buildCachedSnapshotCachePolicy(context: BuildSnapshotContext, storeLookup: StoreLookup<RecordRepresentation>): Snapshot<RecordRepresentation>;
export declare function getRecordByFields(luvio: Luvio, config: GetRecordConfig, requestContext?: AdapterRequestContext): Snapshot<RecordRepresentation> | Promise<Snapshot<RecordRepresentation>>;
