import type { AdapterFactory, DispatchResourceRequestContext, Luvio, Selector, Snapshot, UnfulfilledSnapshot } from '@luvio/engine';
import type { GetRecordUiConfig } from '../../generated/adapters/getRecordUi';
import type { RecordUiRepresentation } from '../../generated/types/RecordUiRepresentation';
import type { LayoutType } from '../../primitives/LayoutType';
import type { LayoutMode } from '../../primitives/LayoutMode';
type GetRecordUiConfigWithDefaults = Omit<Required<GetRecordUiConfig>, 'formFactor' | 'childRelationships' | 'pageSize' | 'updateMru'> & {
    layoutTypes: LayoutType[];
    modes: LayoutMode[];
};
export declare function buildCachedSnapshot(luvio: Luvio, config: GetRecordUiConfigWithDefaults): Snapshot<RecordUiRepresentation> | null | UnfulfilledSnapshot<RecordUiRepresentation | Selector, any>;
export declare function buildNetworkSnapshot(luvio: Luvio, config: GetRecordUiConfigWithDefaults, dispatchContext?: DispatchResourceRequestContext): Promise<Snapshot<RecordUiRepresentation>>;
export declare function coerceConfigWithDefaults(untrustedConfig: unknown): GetRecordUiConfigWithDefaults | null;
export declare const factory: AdapterFactory<GetRecordUiConfig, RecordUiRepresentation>;
export {};
