/**
 * Copyright (c) 2022, Salesforce, Inc.,
 * All rights reserved.
 * For full license text, see the LICENSE.txt file
 */

var SnapshotState;
(function (SnapshotState) {
    SnapshotState["Fulfilled"] = "Fulfilled";
    SnapshotState["Unfulfilled"] = "Unfulfilled";
    SnapshotState["Error"] = "Error";
    SnapshotState["Pending"] = "Pending";
    SnapshotState["Stale"] = "Stale";
})(SnapshotState || (SnapshotState = {}));

Promise.resolve();

var StoreErrorStatus;
(function (StoreErrorStatus) {
    StoreErrorStatus[StoreErrorStatus["RESOURCE_NOT_FOUND"] = 404] = "RESOURCE_NOT_FOUND";
})(StoreErrorStatus || (StoreErrorStatus = {}));
var StoreRecordType;
(function (StoreRecordType) {
    StoreRecordType["Error"] = "error";
})(StoreRecordType || (StoreRecordType = {}));
var StoreLinkStateValues$1;
(function (StoreLinkStateValues) {
    StoreLinkStateValues[StoreLinkStateValues["NotPresent"] = 0] = "NotPresent";
    StoreLinkStateValues[StoreLinkStateValues["RefNotPresent"] = 1] = "RefNotPresent";
    StoreLinkStateValues[StoreLinkStateValues["RefPresent"] = 2] = "RefPresent";
    StoreLinkStateValues[StoreLinkStateValues["Null"] = 3] = "Null";
    StoreLinkStateValues[StoreLinkStateValues["Missing"] = 4] = "Missing";
    StoreLinkStateValues[StoreLinkStateValues["Pending"] = 5] = "Pending";
})(StoreLinkStateValues$1 || (StoreLinkStateValues$1 = {}));
var StoreResolveResultState;
(function (StoreResolveResultState) {
    StoreResolveResultState[StoreResolveResultState["Found"] = 0] = "Found";
    StoreResolveResultState[StoreResolveResultState["Error"] = 1] = "Error";
    StoreResolveResultState[StoreResolveResultState["Null"] = 2] = "Null";
    StoreResolveResultState[StoreResolveResultState["NotPresent"] = 3] = "NotPresent";
    StoreResolveResultState[StoreResolveResultState["Stale"] = 4] = "Stale";
})(StoreResolveResultState || (StoreResolveResultState = {}));
var HttpStatusCode;
(function (HttpStatusCode) {
    HttpStatusCode[HttpStatusCode["Ok"] = 200] = "Ok";
    HttpStatusCode[HttpStatusCode["Created"] = 201] = "Created";
    HttpStatusCode[HttpStatusCode["NoContent"] = 204] = "NoContent";
    HttpStatusCode[HttpStatusCode["NotModified"] = 304] = "NotModified";
    HttpStatusCode[HttpStatusCode["BadRequest"] = 400] = "BadRequest";
    HttpStatusCode[HttpStatusCode["Unauthorized"] = 401] = "Unauthorized";
    HttpStatusCode[HttpStatusCode["Forbidden"] = 403] = "Forbidden";
    HttpStatusCode[HttpStatusCode["NotFound"] = 404] = "NotFound";
    HttpStatusCode[HttpStatusCode["ServerError"] = 500] = "ServerError";
    HttpStatusCode[HttpStatusCode["GatewayTimeout"] = 504] = "GatewayTimeout";
})(HttpStatusCode || (HttpStatusCode = {}));
var GraphNodeType;
(function (GraphNodeType) {
    GraphNodeType["Link"] = "Link";
    GraphNodeType["Node"] = "Node";
    GraphNodeType["Error"] = "Error";
    GraphNodeType["Locked"] = "Locked";
})(GraphNodeType || (GraphNodeType = {}));

var StoreLinkStateValues;
(function (StoreLinkStateValues) {
    StoreLinkStateValues[StoreLinkStateValues["NotPresent"] = 0] = "NotPresent";
    StoreLinkStateValues[StoreLinkStateValues["RefNotPresent"] = 1] = "RefNotPresent";
    StoreLinkStateValues[StoreLinkStateValues["RefPresent"] = 2] = "RefPresent";
    StoreLinkStateValues[StoreLinkStateValues["Null"] = 3] = "Null";
    StoreLinkStateValues[StoreLinkStateValues["Missing"] = 4] = "Missing";
    StoreLinkStateValues[StoreLinkStateValues["Pending"] = 5] = "Pending";
})(StoreLinkStateValues || (StoreLinkStateValues = {}));
var FragmentReadResultState;
(function (FragmentReadResultState) {
    FragmentReadResultState[FragmentReadResultState["Missing"] = 0] = "Missing";
    FragmentReadResultState[FragmentReadResultState["Success"] = 1] = "Success";
    FragmentReadResultState[FragmentReadResultState["Error"] = 2] = "Error";
})(FragmentReadResultState || (FragmentReadResultState = {}));
({
    state: FragmentReadResultState.Missing,
});

var ResourceParamType;
(function (ResourceParamType) {
    ResourceParamType[ResourceParamType["UrlParameter"] = 0] = "UrlParameter";
    ResourceParamType[ResourceParamType["QueryParameter"] = 1] = "QueryParameter";
    ResourceParamType[ResourceParamType["Body"] = 2] = "Body";
    ResourceParamType[ResourceParamType["Header"] = 3] = "Header";
})(ResourceParamType || (ResourceParamType = {}));
var TypeCheckShapes;
(function (TypeCheckShapes) {
    TypeCheckShapes[TypeCheckShapes["String"] = 0] = "String";
    TypeCheckShapes[TypeCheckShapes["Boolean"] = 1] = "Boolean";
    TypeCheckShapes[TypeCheckShapes["Number"] = 2] = "Number";
    TypeCheckShapes[TypeCheckShapes["Integer"] = 3] = "Integer";
    TypeCheckShapes[TypeCheckShapes["Unsupported"] = 4] = "Unsupported";
})(TypeCheckShapes || (TypeCheckShapes = {}));
// engine version: 0.157.4-1c316582

const { keys: ObjectKeys, create: ObjectCreate } = Object;

const { assign, create, freeze, isFrozen, keys } = Object;

function isString(value) {
    return typeof value === 'string';
}

function isFieldId(unknown) {
    if (typeof unknown !== 'object' || unknown === null) {
        return false;
    }
    const value = unknown;
    return isString(value.objectApiName) && isString(value.fieldApiName);
}
/**
 * Split the object API name and field API name from a qualified field name.
 * Eg: Opportunity.Title returns ['Opportunity', 'Title']
 * Eg: Opportunity.Account.Name returns ['Opportunity', 'Account.Name']
 * @param fieldApiName The qualified field name.
 * @return The object and field API names.
 */
function splitQualifiedFieldApiName(fieldApiName) {
    const idx = fieldApiName.indexOf('.');
    if (idx < 1) {
        // object api name must non-empty
        throw new TypeError('Value does not include an object API name.');
    }
    return [fieldApiName.substring(0, idx), fieldApiName.substring(idx + 1)];
}

/**
 * Returns the field API name, qualified with an object name if possible.
 * @param value The value from which to get the qualified field API name.
 * @param onlyQualifiedFieldNames - Whether or not this function should skip fieldApiName that do not include the delimiter '.'
 * @return The qualified field API name.
 */
function getFieldApiName(value, onlyQualifiedFieldNames = false) {
    // Note: tightening validation logic changes behavior from userland getting
    // a server-provided error to the adapter noop'ing. In 224 we decided to not
    // change the behavior. In 250 we decided to add the 'onlyQualifiedFieldName' flag to tighten the logic
    // optionally to avoid issues with persisted invalid field names.
    if (isString(value)) {
        const trimmed = value.trim();
        if (trimmed.length > 0 && (onlyQualifiedFieldNames ? trimmed.indexOf('.') > -1 : true)) {
            return trimmed;
        }
    }
    else if (isFieldId(value)) {
        return value.objectApiName + '.' + value.fieldApiName;
    }
    return undefined;
}

/**
 * Defines configuration for the module with a default value which can be overridden by the runtime environment.
 */
// A holder for a configurable adapter override
class Configurable {
    constructor() {
        this.getAdapter = () => {
            return this.adapter;
        };
        this.setAdapter = (value) => {
            this.adapter = value;
        };
        this.adapter = undefined;
    }
}
// Configurable adapters that can have environmental overrides
let configurableCreateRecordAdapter = new Configurable();
let configurableUpdateRecordAdapter = new Configurable();
let configurableDeleteRecordAdapter = new Configurable();
let configurablePerformQuickActionAdapter = new Configurable();
let configurablePerformUpdateRecordQuickActionAdapter = new Configurable();
let configurableCreateContentDocumentAndVersion = new Configurable();
let configurableCreateContentVersion = new Configurable();
/**
 * Depth to which tracked fields will be added to a request that results from a cache miss.
 * A value of 0 inhibits the addition of tracked fields, 1 will add tracked fields that can
 * be reached by following 1 relationship from the root record, etc.
 * @defaultValue '5', replicates the current behavior
 */
let trackedFieldDepthOnCacheMiss = 5;
/**
 * Depth to which tracked fields will be added to a request that results from a merge conflict
 * A value of 0 inhibits the addition of tracked fields, 1 will add tracked fields that can
 * be reached by following 1 relationship from the root record, etc.
 * @defaultValue '5', replicates the current behavior
 */
let trackedFieldDepthOnCacheMergeConflict = 5;
/**
 * Depth to which tracked fields will be added to a request that results from a notify change invocation by the consumer
 * A value of 0 inhibits the addition of tracked fields, 1 will add tracked fields that can
 * be reached by following 1 relationship from the root record, etc.
 * @defaultValue '5', replicates the current behavior
 */
let trackedFieldDepthOnNotifyChange = 5;
/**
 * Determines if we will only fetch the 'Id' field for the leaf relationship record
 * @defaultValue 'false', replicates the current behavior and fetches all fields in the store for the leaf relationship record
 */
let trackedFieldLeafNodeIdAndNameOnly = false;
/**
 * One store enabled Get Object Info adapter
 */
let oneStoreGetObjectInfoAdapter = undefined;
/**
 * One store enabled Get Object Infos adapter
 */
let oneStoreGetObjectInfosAdapter = undefined;
/**
 * Determines when to include PDL strategies for Related Lists
 */
let relatedListsPredictionsEnabled = false;
/**
 * Determines whether to include additional PDL strategies for Related Lists
 */
let relatedListsPlusPredictionsEnabled = false;
let recordRepresentationIngestionOverride = undefined;
/**
 * Defines the configuration API and is exposed internally as well as externally.
 * Configuration for one store enabled REST adapters only.
 */
const configurationForOneStoreEnabledAdapters = {
    setGetObjectInfoAdapter: function (adapter) {
        oneStoreGetObjectInfoAdapter = adapter;
    },
    getGetObjectInfoAdapter: function () {
        return oneStoreGetObjectInfoAdapter;
    },
    setGetObjectInfosAdapter: function (adapter) {
        oneStoreGetObjectInfosAdapter = adapter;
    },
    getGetObjectInfosAdapter: function () {
        return oneStoreGetObjectInfosAdapter;
    },
};
const getKeywordSearchResultsFactory = new Configurable();
const getListRecordsByNameFactory = new Configurable();
const getListUiFactory = new Configurable();
const getLookupRecordsFactory = new Configurable();
const getQuickActionDefaultsFactory = new Configurable();
const getRecordCreateDefaultsFactory = new Configurable();
const getRecordTemplateCloneFactory = new Configurable();
const getRecordTemplateCreateFactory = new Configurable();
const getRecordUiFactory = new Configurable();
const getRecordFactory = new Configurable();
const getRecordsFactory = new Configurable();
const getRelatedListRecordsFactory = new Configurable();
const getRelatedListRecordsBatchFactory = new Configurable();
const getSearchResultsFactory = new Configurable();
// The following set of adapters all touch RecordRepresentation directly or indirectly,
// so they need to support having a custom factory provided by the mobile environment.
const configurationForEnvironmentFactoryOverrides = {
    getKeywordSearchResultsAdapterFactory: getKeywordSearchResultsFactory.getAdapter,
    setGetKeywordSearchResultsAdapterFactory: getKeywordSearchResultsFactory.setAdapter,
    getListRecordsByNameAdapterFactory: getListRecordsByNameFactory.getAdapter,
    setGetListRecordsByNameAdapterFactory: getListRecordsByNameFactory.setAdapter,
    getListUiAdapterFactory: getListUiFactory.getAdapter,
    setGetListUiAdapterFactory: getListUiFactory.setAdapter,
    getLookupRecordsAdapterFactory: getLookupRecordsFactory.getAdapter,
    setGetLookupRecordsAdapterFactory: getLookupRecordsFactory.setAdapter,
    getQuickActionDefaultsAdapterFactory: getQuickActionDefaultsFactory.getAdapter,
    setGetQuickActionDefaultsAdapterFactory: getQuickActionDefaultsFactory.setAdapter,
    getRecordCreateDefaultsAdapterFactory: getRecordCreateDefaultsFactory.getAdapter,
    setGetRecordCreateDefaultsAdapterFactory: getRecordCreateDefaultsFactory.setAdapter,
    getRecordTemplateCloneAdapterFactory: getRecordTemplateCloneFactory.getAdapter,
    setGetRecordTemplateCloneAdapterFactory: getRecordTemplateCloneFactory.setAdapter,
    getRecordTemplateCreateAdapterFactory: getRecordTemplateCreateFactory.getAdapter,
    setGetRecordTemplateCreateAdapterFactory: getRecordTemplateCreateFactory.setAdapter,
    getRecordUiAdapterFactory: getRecordUiFactory.getAdapter,
    setGetRecordUiAdapterFactory: getRecordUiFactory.setAdapter,
    getRecordAdapterFactory: getRecordFactory.getAdapter,
    setGetRecordAdapterFactory: getRecordFactory.setAdapter,
    getRecordsAdapterFactory: getRecordsFactory.getAdapter,
    setGetRecordsAdapterFactory: getRecordsFactory.setAdapter,
    getRelatedListRecordsAdapterFactory: getRelatedListRecordsFactory.getAdapter,
    setGetRelatedListRecordsAdapterFactory: getRelatedListRecordsFactory.setAdapter,
    getRelatedListRecordsBatchAdapterFactory: getRelatedListRecordsBatchFactory.getAdapter,
    setGetRelatedListRecordsBatchAdapterFactory: getRelatedListRecordsBatchFactory.setAdapter,
    getSearchResultsAdapterFactory: getSearchResultsFactory.getAdapter,
    setGetSearchResultsAdapterFactory: getSearchResultsFactory.setAdapter,
};
/**
 * Defines the configuration API and is exposed internally as well as externally.
 * Configuration for REST adapters only.
 */
({
    setTrackedFieldDepthOnCacheMiss: function (trackedFieldDepthOnCacheMissParam) {
        trackedFieldDepthOnCacheMiss = trackedFieldDepthOnCacheMissParam;
    },
    getTrackedFieldDepthOnCacheMiss: function () {
        return trackedFieldDepthOnCacheMiss;
    },
    setTrackedFieldDepthOnCacheMergeConflict: function (trackedFieldDepthOnCacheMergeConflictParam) {
        trackedFieldDepthOnCacheMergeConflict = trackedFieldDepthOnCacheMergeConflictParam;
    },
    getTrackedFieldDepthOnCacheMergeConflict: function () {
        return trackedFieldDepthOnCacheMergeConflict;
    },
    setTrackedFieldDepthOnNotifyChange: function (trackedFieldDepthOnNotifyChangeParam) {
        trackedFieldDepthOnNotifyChange = trackedFieldDepthOnNotifyChangeParam;
    },
    getTrackedFieldDepthOnNotifyChange: function () {
        return trackedFieldDepthOnNotifyChange;
    },
    setTrackedFieldLeafNodeIdAndNameOnly: function (trackedFieldLeafNodeIdAndNameOnlyParam) {
        trackedFieldLeafNodeIdAndNameOnly = trackedFieldLeafNodeIdAndNameOnlyParam;
    },
    getTrackedFieldLeafNodeIdAndNameOnly: function () {
        return trackedFieldLeafNodeIdAndNameOnly;
    },
    setRelatedListsPredictionsEnabled: function (f) {
        relatedListsPredictionsEnabled = f;
    },
    areRelatedListsPredictionsEnabled: function () {
        return relatedListsPredictionsEnabled === true;
    },
    setRelatedListsPlusPredictionsEnabled: function (f) {
        relatedListsPlusPredictionsEnabled = f;
    },
    areRelatedListsPlusPredictionsEnabled: function () {
        return relatedListsPlusPredictionsEnabled === true;
    },
    setRecordRepresentationIngestionOverride: function (ingest) {
        recordRepresentationIngestionOverride = ingest;
    },
    getRecordRepresentationIngestionOverride: function () {
        return recordRepresentationIngestionOverride;
    },
    // createRecord
    getDraftAwareCreateRecordAdapter: configurableCreateRecordAdapter.getAdapter,
    setDraftAwareCreateRecordAdapter: configurableCreateRecordAdapter.setAdapter,
    // updateRecord
    getDraftAwareUpdateRecordAdapter: configurableUpdateRecordAdapter.getAdapter,
    setDraftAwareUpdateRecordAdapter: configurableUpdateRecordAdapter.setAdapter,
    // deleteRecord
    getDraftAwareDeleteRecordAdapter: configurableDeleteRecordAdapter.getAdapter,
    setDraftAwareDeleteRecordAdapter: configurableDeleteRecordAdapter.setAdapter,
    // performQuickAction
    getDraftAwarePerformQuickActionAdapter: configurablePerformQuickActionAdapter.getAdapter,
    setDraftAwarePerformQuickActionAdapter: configurablePerformQuickActionAdapter.setAdapter,
    // performRecordUpdateQuickAction
    getDraftAwarePerformUpdateRecordQuickActionAdapter: configurablePerformUpdateRecordQuickActionAdapter.getAdapter,
    setDraftAwarePerformUpdateRecordQuickActionAdapter: configurablePerformUpdateRecordQuickActionAdapter.setAdapter,
    // createContentDocumentAndVersion
    getDraftAwareCreateContentDocumentAndVersionAdapter: configurableCreateContentDocumentAndVersion.getAdapter,
    setDraftAwareCreateContentDocumentAndVersionAdapter: configurableCreateContentDocumentAndVersion.setAdapter,
    // createContentVersion
    getDraftAwareCreateContentVersionAdapter: configurableCreateContentVersion.getAdapter,
    setDraftAwareCreateContentVersionAdapter: configurableCreateContentVersion.setAdapter,
    ...configurationForOneStoreEnabledAdapters,
    ...configurationForEnvironmentFactoryOverrides,
});
let configurableGraphQLAdapter = new Configurable();
let configurableGraphQLBatchAdapter = new Configurable();
/**
 * Defines the configuration API and is exposed internally as well as externally.
 * Configuration for GraphQL adapters only.
 */
({
    getDraftAwareGraphQLAdapter: configurableGraphQLAdapter.getAdapter,
    setDraftAwareGraphQLAdapter: configurableGraphQLAdapter.setAdapter,
    getEnvironmentAwareGraphQLBatchAdapter: configurableGraphQLBatchAdapter.getAdapter,
    setEnvironmentAwareGraphQLBatchAdapter: configurableGraphQLBatchAdapter.setAdapter,
});

ObjectCreate(null);

ObjectCreate(null);

freeze({
    name: '',
    children: {},
});
/**
 * Returns a new object that has a list of fields that has been filtered by
 * edited fields. Only contains fields that have been edited from their original
 * values (excluding Id which is always copied over).
 * @param input The RecordInputRepresentation object to filter.
 * @param original The Record object that contains the original field values.
 * @returns RecordInputRepresentation, see the description
 */
function createRecordInputFilteredByEditedFields(input, original) {
    const filteredRecordInput = getRecordInput();
    // Always copy over any existing id.
    if (original.id) {
        filteredRecordInput.fields.Id = original.id;
    }
    const recordInputFields = input.fields;
    const originalRecordFields = original.fields;
    const recordInputFieldPropertyNames = keys(recordInputFields);
    for (let i = 0, len = recordInputFieldPropertyNames.length; i < len; i++) {
        const fieldName = recordInputFieldPropertyNames[i];
        let originalRecordFieldsEntry;
        if (originalRecordFields) {
            originalRecordFieldsEntry = originalRecordFields[fieldName];
        }
        if (!originalRecordFieldsEntry ||
            (originalRecordFields &&
                recordInputFields[fieldName] !== originalRecordFieldsEntry.value)) {
            filteredRecordInput.fields[fieldName] = recordInputFields[fieldName];
        }
    }
    return filteredRecordInput;
}
/**
 * Returns an object with its data populated from the given record. All fields
 * with values that aren't nested records will be assigned. This object can be
 * used to create a record.
 * @param record The record that contains the source data.
 * @param objectInfo The ObjectInfo corresponding to the apiName on the record.
 *        If provided, only fields that are createable=true (excluding Id) will
 *        be assigned to the object return value.
 * @returns RecordInputRepresentation See description.
 */
function generateRecordInputForCreate(record, objectInfo) {
    const recordInput = _generateRecordInput(record, (field) => field.createable === true, objectInfo);
    recordInput.apiName = record.apiName;
    // fields.Id is not required for CREATE which might have been copied over,
    // so delete fields.Id
    delete recordInput.fields.Id;
    return recordInput;
}
/**
 * Returns an object with its data populated from the given record. All fields
 * with values that aren't nested records will be assigned. This object can be
 * used to update a record.
 * @param record The record that contains the source data.
 * @param objectInfo The ObjectInfo corresponding to the apiName on the record.
 *        If provided, only fields that are updateable=true (excluding Id) will
 *        be assigned to the object return value.
 * @returns RecordInputRepresentation See description.
 */
function generateRecordInputForUpdate(record, objectInfo) {
    const recordInput = _generateRecordInput(record, (field) => field.updateable === true, objectInfo);
    if (!record.id) {
        if (process.env.NODE_ENV !== 'production') {
            throw new Error('record must have id for update');
        }
    }
    // Always copy over any existing id.
    recordInput.fields.Id = record.id;
    return recordInput;
}
function isRecordInputFieldValue(unknown) {
    const type = typeof unknown;
    return unknown === null || type === 'string' || type === 'number' || type === 'boolean';
}
/**
 * Returns an object with its data populated from the given record. All fields
 * with values that aren't nested records will be assigned.
 * @param record The record that contains the source data.
 * @param copyFieldPredicate predicate to determine if a field should be copied.
 *        Required if "objectInfo" parameter is passed.
 * @param objectInfo The ObjectInfo corresponding to the apiName on the record.
 *        If provided, only fields that match the copyFieldPredicate (excluding
 *        Id) will be assigned to the object return value.
 * @returns RecordInputRepresentation
 */
function _generateRecordInput(record, copyFieldPredicate, objectInfo) {
    const recordInput = getRecordInput();
    const recordFields = record.fields;
    let objectInfoFields;
    if (objectInfo) {
        objectInfoFields = objectInfo.fields;
    }
    const recordFieldPropertyNames = keys(recordFields);
    for (let i = 0, len = recordFieldPropertyNames.length; i < len; i++) {
        const fieldName = recordFieldPropertyNames[i];
        const recordFieldsFieldNameEntry = recordFields[fieldName].value;
        if (isRecordInputFieldValue(recordFieldsFieldNameEntry)) {
            if (objectInfoFields && copyFieldPredicate) {
                const objectInfoFieldsFieldNameValue = objectInfoFields[fieldName];
                if (objectInfoFieldsFieldNameValue &&
                    copyFieldPredicate(objectInfoFieldsFieldNameValue)) {
                    recordInput.fields[fieldName] = recordFieldsFieldNameEntry;
                }
            }
            else {
                recordInput.fields[fieldName] = recordFieldsFieldNameEntry;
            }
        }
    }
    return recordInput;
}
/**
 * Gets a new Record Input.
 */
function getRecordInput() {
    return {
        apiName: undefined,
        fields: {},
    };
}
/**
 * Gets a field's value from a record.
 * @param record The record.
 * @param field The qualified API name of the field to return.
 * @returns The field's value (which may be a record in the case of spanning
 *          fields), or undefined if the field isn't found.
 */
function getFieldValue(record, field) {
    const fieldValueRepresentation = getField(record, field);
    if (fieldValueRepresentation === undefined) {
        return undefined;
    }
    if (isFieldValueRepresentation(fieldValueRepresentation)) {
        return fieldValueRepresentation.value;
    }
    return fieldValueRepresentation;
}
/**
 * Gets a field's display value from a record.
 * @param record The record.
 * @param field The qualified API name of the field to return.
 * @returns The field's display value, or undefined if the field isn't found.
 */
function getFieldDisplayValue(record, field) {
    const fieldValueRepresentation = getField(record, field);
    if (fieldValueRepresentation === undefined) {
        return undefined;
    }
    if (isFieldValueRepresentation(fieldValueRepresentation)) {
        return fieldValueRepresentation.displayValue;
    }
    return fieldValueRepresentation;
}
function isFieldValueRepresentation(unknown) {
    if (typeof unknown !== 'object' || unknown === null) {
        return false;
    }
    return 'value' in unknown && 'displayValue' in unknown;
}
function getField(record, field) {
    const fieldApiName = getFieldApiName(field);
    if (fieldApiName === undefined) {
        return undefined;
    }
    const unqualifiedField = splitQualifiedFieldApiName(fieldApiName)[1];
    const fields = unqualifiedField.split('.');
    let r = record;
    while (r && r.fields) {
        const f = fields.shift();
        const fvr = r.fields[f];
        if (fvr === undefined) {
            return undefined;
        }
        else if (fields.length > 0) {
            r = fvr.value;
        }
        else {
            return fvr;
        }
    }
    return r;
}

export { createRecordInputFilteredByEditedFields, generateRecordInputForCreate, generateRecordInputForUpdate, getFieldDisplayValue, getFieldValue, getRecordInput };
